const
  mini2: array[1..3, 1..2] of Integer=((1,1),(2,1),(2,2));
  mini1: array[1..2, 1..3] of Integer=((1,1,2),(1,2,2));

var
  desk: array[0..16, 0..16] of Integer;
  c: Integer;
  M, N: Integer;

procedure WriteData;
var F: Text; i, j: Integer;
begin
  Assign(F, 'board.out');
  Rewrite(F);
  if ((m*n mod 3)=0) then
    if ((m mod 3=0)and(n mod 2 <> 0))or((m mod 2<>0)and(n mod 3=0)) then
      begin
      writeln(F,0);
      Close(F);
      exit;
      end;
  for j:=1 to M do
    begin
    for i:=1 to N do
      write(F, desk[j, i] :2, ' ');
    writeln(F);
    end;
  Close(F);
end;


{procedure Full;
var i, j: Integer; ok: Boolean;
begin
  ok:=true;
  for j:=1 to N do
    for i:=1 to M do
      if desk[i, j]=0 then
        begin
        ok:=false;
        inc(c);
        desk[i, j]:=c;
        if desk[i, j+1]=0 then
          begin
          desk[i, j+1]:=c;
          if desk[i+1, j+1]=0 then
            begin
            desk[i+1, j+1]:=c;
            Full;
            desk[i+1, j+1]:=0;
            end;
          if desk[i-1, j+1]=0 then
            begin
            desk[i-1, j+1]:=c;
            Full;
            desk[i-1, j+1]:=0;
            end;
          desk[i, j+1]:=0;
          end;

        if desk[i-1, j]=0 then
          begin
          desk[i-1, j]:=c;
          if desk[i-1, j+1]=0 then
            begin
            desk[i-1, j+1]:=c;
            Full;
            desk[i-1, j+1]:=0;
            end;
          if desk[i-1, j-1]=0 then
            begin
            desk[i-1, j-1]:=c;
            Full;
            desk[i-1, j-1]:=0;
            end;
          desk[i-1, j]:=0;
          end;

        if desk[i, j-1]=0 then
          begin
          desk[i, j-1]:=c;
          if desk[i-1, j-1]=0 then
            begin
            desk[i-1, j-1]:=c;
            Full;
            desk[i-1, j-1]:=0;
            end;
          if desk[i+1, j-1]=0 then
            begin
            desk[i+1, j-1]:=c;
            Full;
            desk[i+1, j-1]:=0;
            end;
          desk[i, j-1]:=0;
          end;

        if desk[i+1, j]=0 then
          begin
          desk[i+1, j]:=c;
          if desk[i+1, j-1]=0 then
            begin
            desk[i+1, j-1]:=c;
            Full;
            desk[i+1, j-1]:=0;
            end;
          if desk[i+1, j+1]=0 then
            begin
            desk[i+1, j+1]:=c;
            Full;
            desk[i+1, j+1]:=0;
            end;
          desk[i+1, j]:=0;
          end;
        dec(c);
        desk[i, j]:=0;
        end;
  if ok then WriteData;
end;}

procedure Solve;
var i, j, x, y, u, v: Integer;
begin
  if (m mod 3=0) then
    begin
    i:=m div 3;
    j:=n div 2;
    for y:=0 to j-1 do
      for x:=0 to i-1 do
        begin
        for u:=1 to 2 do
          for v:=1 to 3 do
            desk[x*3+v, y*2+u]:=mini2[v, u]+c;
        c:=c+2;
        end;
    end
  else
    begin
    i:=m div 2;
    j:=n div 3;
    for y:=0 to j-1 do
      for x:=0 to i-1 do
        begin
        for u:=1 to 3 do
          for v:=1 to 2 do
            desk[x*2+v, y*3+u]:=mini1[v, u]+c;
        c:=c+2;
        end;
    end;
end;

procedure ReadData;
var F: Text;i: Integer;
begin
  Assign(F, 'board.inp');
  Reset(F);
  readln(F, m, n);
  Close(F);
  for i:=1 to n do
    begin
    desk[0, i]:=1;
    desk[m+1, i]:=1;
    end;
  for i:=1 to m do
    begin
    desk[i, 0]:=1;
    desk[i, n+1]:=1;
    end;
end;

begin
  c:=0;
  fillchar(desk, sizeof(desk), 0);
  ReadData;
  Solve;
  WriteData;
end.