#include <stdio.h>

FILE *fn;
int n, m;
int neis[1024];
short nei[1024][1024][2];
char where[1024][1024];
int path[1024];
int reaches, starts;
int reached[1024];
int inuse[1024];
int wto[1024];

int dfs(int a) {
  int i, j;

  inuse[a]=1;
  for (i=1; i<neis[a]; i++) {
    j=nei[a][i][1];
    if (!reached[j]) {
      path[j]=path[a]+nei[a][i][0];
      reached[j]=1;
      reaches++;
      if (dfs(j)) break;
    } else {
      if (path[j]>path[a]+nei[a][i][0]) {
        if (inuse[j]) break;
        else {
          path[j]=path[a]+nei[a][i][0];
          if (dfs(j)) break;
        }
      }
    }
  }
  inuse[a]=0;
  if (i<neis[a]) return 1;
  else return 0;
}

int cmp(short *a, short *b) {
  return (*a-*b);
}

int main(void) {
int i, t1, t2, t3, br=0;

fn=fopen("WORK.INP", "r");
fscanf(fn, "%d %d", &n, &m);
for (i=1; i<=n; i++) neis[i]=1;
for (i=0; i<m; i++) {
  fscanf(fn, "%d %d %d", &t1, &t2, &t3);
  if (where[t1][t2]) {
    if (t3<nei[t1][where[t1][t2]][0]) nei[t1][where[t1][t2]][0]=t3;
  } else {
    nei[t1][neis[t1]][1]=t2;
    nei[t1][neis[t1]][0]=t3;
    where[t1][t2]=neis[t1];
    neis[t1]++;
    wto[t2]++;
  }
}
fclose(fn);

for (i=1; i<=n; i++) qsort(nei[i][1], neis[i]-1, 4, cmp);

while (reaches<n && !br) {
  t1=1;
  for (i=2; i<=n; i++) if ((!reached[i]) && wto[i]<wto[t1]) t1=i;
  reached[t1]=1;
  path[t1]=starts*1000000;
  starts++;
  reaches++;
  br=dfs(t1);
}

fn=fopen("WORK.OUT", "w");
if (br) {
  fprintf(fn, "NO SOLUTION\n");
} else {
  t1=1;
  for (i=2; i<=n; i++) if (path[i]>path[t1]) t1=i;
  t1=path[t1];
  for (i=1; i<=n; i++) fprintf(fn, "%d\n", t1-path[i]);
}
fclose(fn);

return 0;
}
