/* INCLUDE ******************************************************************/
   #include <fstream>
   #include <cstdlib>
   #include <cmath>

   #include <vector>
   #include <algorithm>

   using namespace std;

/* CONSTANTS ****************************************************************/
/* CLASSES ******************************************************************/
/* GLOBALS ******************************************************************/
   ifstream fin("drain.inp");
   ofstream fout("drain.out");

   int res;
   int all_q;

   int c_d;
   vector<int> d;
   vector<int> q;

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
   void done()
   {
      fin.close();
      fout.close();
      exit(0);
   }
/****************************************************************************/
   void init()
   {
      fin >> c_d;
      d.resize(c_d);
      q.resize(c_d);

      for (int i = 0; i < c_d; ++i)
      {
         int d0;
         int q0;

         fin >> d0 >> q0;

         all_q += q0;
         d[i] = d0;
         q[i] = q0;
      }
   }
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
   void run()
   {
      int qr = all_q - q[0];
      int r1 = qr;
      
      for (int i = 1; i < c_d; ++i)
      {
         r1 += qr*(d[i] - d[i-1]);
         qr -= q[i];
      }

      //
      qr = all_q - q[c_d - 1];
      int r2 = qr;
      
      for (int i = c_d - 2; i >= 0; --i)
      {
         r2 += qr*(d[i + 1] - d[i]);
         qr -= q[i];
      }


      if (r1 < r2)
      {
         fout << "1" << endl;
         fout << r1 << endl;
      } else
         {
            fout << c_d - 1 << endl;
            fout << r2 << endl;
         }

   }
/****************************************************************************/
   int main()
   {
      init();
      run();
      done();

      return 0;
   }
/****************************************************************************/

