#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define inp "work.inp"
#define out "work.out"

#define MAXN 5010
#define MAXW 1010
#define UPL 40

struct nerav { int x,y,z; };
struct limit { int l,r; };
nerav it[MAXN];
limit l[MAXW];
int ner[MAXW],can[MAXW],pos[MAXW],v[MAXW],c[MAXW];
int t = 0;
int n,m;

int min ( int x,int y) { if (x<y) return x; else return y; }
int max ( int x,int y) { if (x>y) return x; else return y; }


void init () {
int i,x,y,z;
     FILE *f = fopen ( inp , "r");
     fscanf(f,"%d%d",&n,&m);
     for (i=1;i<=n;i++) { can[i] = 1; ner[i] = 0; }
     for (i=1;i<=m;i++) {
         fscanf(f,"%d%d%d",&x,&y,&z);
         it[i].x = x;it[i].y = y;it[i].z = z;
         if (z<0) can[y] = 0;
         ner[x]++;ner[y]++;
     }
     fclose(f);
     for (i=1;i<=n;i++) {
         if (can[i]) pos[++t] = i;
         l[i].l = 0;
         l[i].r = UPL;
     }
}

void no() {
     FILE *f = fopen ( out,"w");
     fprintf(f,"NO SOLUTION\n");
     fclose(f);
     exit(0);
}

void output() {
int e;
     FILE *f = fopen ( out, "w");
     for (e=1;e<=n;e++)
         fprintf(f,"%d\n",v[e]);
     fclose(f);
     exit(0);
}

void check () {
int i;
     for (i=1;i<=m;i++) {
         if ((v[it[i].x]-v[it[i].y])>it[i].z)
            return;
     }
     output();
}

void cut (int index,int value) {
int i;
     for (i=1;i<=m;i++) {
         if (it[i].x==index) {
            l[it[i].y].l = max ( l[it[i].y].l , value-it[i].z );
         }
         if (it[i].y==index) {
            l[it[i].y].r = min ( l[it[i].y].r , it[i].z-value );
         }
     }
}

int possible (int index) {
int i;
    for (i=1;i<=m;i++) {
        if (c[it[i].x]&&c[it[i].y]) {
           if ((v[it[i].x]-v[it[i].y])>it[i].z) return 0;
        }
    }
    return 1;
}

void rec(int ind) {
int i;
     if (((float)clock()/CLOCKS_PER_SEC)>1.8) no();
     if (c[ind]==1) {
        rec(ind+1);
        return;
     }
     if (ind==(n+1)) {
        check();
        return;
     }
     c[ind] = 1;
     for (i=l[ind].l;i<=l[ind].r;i++) {
         v[ind] = i;
         if (possible(ind))
         rec(ind+1);
     }
     c[ind] = 0;
}

void one () {
int i;
     FILE *f = fopen ( out, "w");
     for (i=1;i<=n;i++) v[i] = 0;
     i = 1;
     if (it[i].z>0) {
        v[it[i].x] = 0;
        v[it[i].y] = 0;
     } else {
             v[it[i].y] = abs(it[i].z);
             v[it[i].x] = 0;
            }
     for (i=1;i<=n;i++)
         fprintf(f,"%d\n",v[i]);
     fclose(f);
     exit(0);
}

void solve () {
int i,j;
     if (t==0) no();
     if (m==1) one();
     for (i=1;i<=t;i++) {
         memset(&c,0,sizeof(c));
         v[i] = 0;
         c[i] = 1;
/*         for (j=1;j<=m;j++) {
             if (it[j].x==i) {
                if (it[j].z>0) {
                   l[it[j].y].l = max (l[it[j].y].l,it[j].z);
                }
             }
             if (it[j].y==i) {
                l[it[j].x].r = min(l[it[j].x].r,it[j].z);
             }
         }*/
         rec(1);
     }
     no();
}

int main () {
    clock();
    init ();
    solve();
    return 0;
}
