uses dos;
const  infile = 'drain.inp';
      outfile = 'drain.out';
          MAX = 32768;
      mdconst = 1;
        crit  = 4.86;

type  tHole = record
              a : integer;
              d : longint;
              end;

      arr   = array [1..300] of THole;
      Fixed = array [1..300] of boolean;
      brrel = record
              D : longint;
              f : Fixed;
              cp: integer;
              l : integer;
              end;
      brr   = array [0..MAX] of brrel;
      brr2  = array [0..mdconst*MAX] of brrel;
      TList = array [1..300] of longint;
      tlistptr = ^Tlist;
      TLe   = record
              c : integer;
              l : TListPtr;
              end;
      TL    = array [0..MAX] of TLe;


var N : integer;
    a : arr;
    c : brr2;
    d : brr;
    e : TL;
    besthole,bestd : longint;
    gl : longint;
    maxk : longint;
    clk  : extended;


function clk0 : extended;
 var h,m,s,hds : word;
     x : extended;
 begin
 gettime(h,m,s,hds);
 x := hds/100 + s;
 x := x + m*60.0 + h * 3600.0;
 clk0:=x;
 end;


Procedure InX;
 var t : text;
     i : integer;
 begin
 assign(t, infile);
 reset(t);
 readln(t,n);
 for i := 1 to n do readln(t, a[i].a,a[i].d);
 close(t);
 end;

Procedure Sw(var a,b : THole);
 var c : THole;
 begin
 c:=a;
 a:=b;
 b:=c;
 end;

Procedure sort;
 var i,d : integer;
     f   : boolean;
 begin
 d:=n-1;
 repeat
 f:=FALSE;
 for i:=1 to d do if a[i].a > a[i+1].a then
  begin
  f:=TRUE;
  sw(a[i],a[i+1]);
  end;
 dec(d);
 until not f;
 end;

Procedure addel(nd : longint; fi : fixed; cp,l : integer; k : longint);
 begin
 if k > max then exit;
 if k > maxk then maxk:=k;
 if (e[k].c = 0) and (nd < d[k].d) then
  begin
  d[k].d:=nd;
  d[k].f:=fi;
  d[k].cp:=cp;
  d[k].l:=l;
  exit;
  end;
 if (e[k].c = 0) and (nd = d[k].d) then
  begin
  e[k].c:=2;
  inc(gl);
  new(e[k].l);
  e[k].l^[1]:=gl;
  c[gl]:=d[k];
  inc(gl);
  e[k].l^[2]:=gl;
  c[gl].d:=nd;
  c[gl].f:=fi;
  c[gl].l:=l;
  c[gl].cp:=cp;
  exit;
  end;
 if (e[k].c<>0) and (nd < d[k].d) then
  begin
  e[k].c:=0;
  dispose(e[k].l);
  d[k].d:=nd;
  d[k].f:=fi;
  d[k].l:=l;
  d[k].cp := cp;
  exit;
  end;
 if (e[k].c<>0) and (nd = d[k].d) then
  begin
  inc(e[k].c);
  inc(gl);
  e[k].l^[e[k].c]:=gl;
  c[gl].d:=nd;
  c[gl].f:=fi;
  c[gl].l:=l;
  c[gl].cp := cp;
  exit;
  end;
 end;


Procedure proceedEl(var w : brrel;k : longint);
 var t,i,j : longint;
     l,cp : integer;
     fi  : fixed;
     nd  : longint;
 begin

  l:=w.l;
  cp:=w.cp;
  fi:=w.f;
  i:=cp;
  while (i<=n) and (fi[i]) do inc(i);
  if i <= n then
   begin
   t:=a[i].a-a[cp].a;
   nd:=w.d;
   for j := 1 to n do if not fi[j] then inc(nd,t*a[j].d);
   if nd<=d[k+t].d then
    begin
    fi[i]:=TRUE;
    addel(nd,fi,i,l-1,k+t);
    end;
   fi[i]:=FALSE;
   end;

  i:=cp;
  while (i>0) and (fi[i]) do dec(i);
  if i > 0 then
   begin
   t:=a[cp].a-a[i].a;
   nd:=d[k].d;
   for j:=1 to n do if not fi[j] then inc(nd,t*a[j].d);
   if nd<=d[k+t].d then
    begin
    fi[i]:=TRUE;
    addel(nd,fi,i,l-1,k+t);
    end;
   end;
 end;

Procedure dina;
 var k,i : longint;
 begin
 for k:=0 to MAX do if (d[k].cp <> 0) and (d[k].l > 0)   then
  begin
  if e[k].c= 0 then proceedel(d[k],k)
               else for i:=1 to e[k].c do proceedel(c[e[k].l^[i]],k);
  if k + 1 > maxk then exit;
  end;
 end;

Procedure OutXfast;
 var t : text;
 begin
 assign(t, outfile);
 rewrite(t);
 writeln(t,bestd);
 writeln(t,besthole);
 close(t);
 halt(0);
 end;


Procedure DoWork;
 var i,j : longint;
 begin
 sort;
 bestd := MAXlongint;
 for i:=1 to n do
  begin
  mark(heapptr);
  gl:=0;
  fillchar(d,(maxk+1)*sizeof(brrel),0);
  fillchar(e,sizeof(e),0);
  for j:=1 to MAX do d[j].d:=maxlongint;
  d[0].f[i]:=TRUE;
  d[0].cp:=i;
  d[0].l := n - 1;
  dina;
  for j:=0 to maxk do if (d[j].cp<>0) and ( d[j].l = 0 ) and (bestd > d[j].d) then
   begin
   bestd:=d[j].d;
   besthole:=i;
   end;
  release(heapptr);
  if clk0-clk > crit then outxfast;
  end;
 end;

Procedure OutX;
 var t : text;
 begin
 assign(t, outfile);
 rewrite(t);
 writeln(t,bestd);
 writeln(t,besthole);
 close(t);
 end;

BEGIN
InX;
clk:=clk0;
DoWork;
OutX;
END.
