type
  need = record
           x, y, z : integer;
         end;

var
  a, n, m : integer;
  works : array[1..1000] of integer;
  ner : array[1..5000] of need;
  nerv : array[1..5000] of boolean;
  good : boolean;

Procedure ReadInp;
var
  f : text;
  begin
    good := false;
    assign(f, 'work.inp');
    reset(f);
    readln(f, n, m);
    for a := 1 to m do
      begin
        readln(f, ner[a].x, ner[a].y, ner[a].z);
        if ner[a].z = 0 then
          begin
            good := true;
            works[ner[a].x] := 0;
            nerv[ner[a].x] := true;
          end;
      end;
    close(f);
  end;

Procedure Solution;
var
  IsEnd : boolean;
  t1, t2 : integer;
  begin
    IsEnd := false;
    repeat
      IsEnd := true;
      for a := 1 to m do
      if not nerv[a] then
        begin
          t1 := ner[a].x;
          t2 := ner[a].y;
          if (works[t1] <> 10000) and (works[t2] <> 10000) then
          begin
            if works[t1] - works[t2] > ner[a].z then
              works[t2] := works[t1] - ner[a].z;
            IsEnd := false;
            nerv[a] := true;
          end;
          if (works[t1] <> 10000) and (works[t2] = 10000) then
          begin
            works[t2] := works[t1] - ner[a].z;
            IsEnd := false;
            nerv[a] := true;
          end;
          if (works[t2] <> 10000) and (works[t1] = 10000) then
          begin
            works[t1] := works[t2] + ner[a].z;
            IsEnd := false;
            nerv[a] := true;
          end;
        end;
    until not IsEnd;
  end;

Function Check : boolean;
var
  g : boolean;
  begin
    g := true;
    for a := 1 to n do
      if works[a] < 0 then g := false;
    Check := g;
  end;

Function Check2 : boolean;
var
  g : boolean;
  begin
    g := true;
    for a := 1 to m do
      if ner[a].x - ner[a].y > ner[a].z then
      begin
        g := false;
        Check2 := g;
        exit;
      end;
  end;

Procedure WriteOut;
var
  f : text;
  begin
    assign(f, 'work.out');
    rewrite(f);
    if (not good) or (not Check) or (not Check2) then writeln(f, 'NO SOLUTION')
    else
    for a := 1 to n do writeln(f, works[a]);
    close(f);
  end;

Procedure InitV;
  begin
    for a := 1 to 1000 do works[a] := 10000;
    FillChar(nerv, sizeof(nerv), false);
  end;

begin
  InitV;
  ReadInp;
  if good then Solution;
  WriteOut;
end.
