#include <stdio.h>
#define INP "perm.inp"
#define OUT "perm.out"
#define BIG long double
#define ST "%0.0Lf\n"

BIG m[30][30];

int MAX(int a,int b) { return (a>b)?(a):(b); }
int MIN(int a,int b) { return (a<b)?(a):(b); }


BIG comb(int x,int y) {
BIG sol = 1;
int a,b;
int i;
     if (y==0) return 1;
     a = MAX (y,x-y);
     b = MIN (y,x-y);
     for (i=a+1;i<=x;i++) sol*=i;
     for (i=1;i<=b;i++) sol/=i;
     return sol;
}

int main () {
int i,j,l,n,k;
    FILE *f = fopen ( INP , "r" );
    fscanf(f,"%d%d",&n,&k);
    fclose(f);
    m[1][1] = 1;
    for (i=2;i<=n;i++) m[i][1] = (i-1)*m[i-1][1];
    for (i=2;i<=n;i++)
        for (j=2;j<=k;j++) {
            m[i][j] = 0;
            for (l=1;l<i;l++)
                m[i][j]+=comb(i-1,l-1)*m[i-l][j-1]*m[l][1];
        }
    f = fopen ( OUT, "w");
    fprintf(f,ST,m[n][k]);
    fclose(f);
    return 0;
}
