#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAXN 6245


int N;
int arr1[MAXN][4];
int arr2[MAXN][4];
int p3[4];
int isset;
int P;


void read_all(void);
void do_all(void);
int dist(int *p1, int *p2);
int notmoved(int *p1, int *p2);
void write_all(void);



int main(void)
{
  int i;
  
  FILE *f = fopen("temp", "rt");
  if (f != NULL) {
    for (i = 0; ; i++) {
      if (fscanf(f, "%d %d %d %d", &arr1[i][0], &arr1[i][1], &arr1[i][2], &arr1[i][3]) != 4)  break;
      fscanf(f, "%d %d %d %d", &arr2[i][0], &arr2[i][1], &arr2[i][2], &arr2[i][3]);
    }
    N = i;
    fclose(f);
  }
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  scanf("%d %d %d %d", &arr1[N][0], &arr1[N][1], &arr1[N][2], &arr1[N][3]);
}



void do_all(void)
{
  int i, j;

  N++;
  for (i = 0; i < N; i++) {
    for (j = i+1; j < N; j++) {
      if (dist(&arr1[i][0], &arr1[j][0]) <= 1 && notmoved(&arr1[i][0], &arr1[j][0]))  break;
      if (dist(&arr1[i][0], &arr1[j][2]) <= 1 && notmoved(&arr1[i][0], &arr1[j][2]))  break;
      if (dist(&arr1[i][2], &arr1[j][0]) <= 1 && notmoved(&arr1[i][2], &arr1[j][0]))  break;
      if (dist(&arr1[i][2], &arr1[j][2]) <= 1 && notmoved(&arr1[i][2], &arr1[j][2]))  break;
    }
  }
  if (isset == 0) {
    for (i = 0; i < N; i++) {
      if (notmoved(&arr1[i][0], &arr1[j][0]))  break;
    }
  }
  if (!isset) {
    p3[0] = rand()%100000;
    p3[1] = rand()%100000;
    p3[2] = p3[0];
    p3[3] = p3[1]+1;
  }
  memmove(arr2[N-1], p3, sizeof(p3));
}



int dist(int *p1, int *p2)
{
  return abs(p1[0]-p2[0]) + abs(p1[1]-p2[1]);
}


int notmoved(int *p1, int *p2)
{
  int i;
  int minx, miny, maxx, maxy;

  if (p1[0] < p2[0])  minx = p1[0], maxx = p2[0];
  else                maxx = p1[0], minx = p2[0];
  if (p1[1] < p2[1])  miny = p1[0], maxy = p2[0];
  else                maxy = p1[0], miny = p2[0];
  if (abs(p1[0]-p2[0]) == 1) {
    p3[0] = minx;
    p3[2] = minx+1;//maxx;
    p3[1] = p3[3] = miny;
  }
  else {
    p3[1] = miny;
    p3[3] = miny+1;//maxy;
    p3[0] = p3[2] = minx;
  }
  for (i = 0; i < N; i++) {
    if (memcmp(arr2[i], p3, sizeof(p3)) == 0)  return 1;
    if (memcmp(arr1[i], p3, sizeof(p3)) == 0)  return 1;
  }
  isset = 1;
  return 0;
}


void write_all(void)
{
  FILE *f = fopen("temp", "at");
  fprintf(f, "%d %d %d %d\n", arr1[N-1][0], arr1[N-1][1], arr1[N-1][2], arr1[N-1][3]);
  fprintf(f, "%d %d %d %d\n", arr2[N-1][0], arr2[N-1][1], arr2[N-1][2], arr2[N-1][3]);
  fclose(f);
  printf("%d %d %d %d\n", arr2[N-1][0], arr2[N-1][1], arr2[N-1][2], arr2[N-1][3]);
}

