#include <stdio.h>

int used[21];
int data[21];
int num;
long cycles[21];
int used_b[21];
int used_c;


FILE *fp;

int eval(void)  {
  long l = 0l;
  int t;
  int next = -1;

  while(used_c < num)  {
    t = 0;
    while(used_b[t] && t < num) t++;

    if(t == num) break;

    if(data[t]-1 == t)  {
      used_b[t] = 1;
      used_c++;
      l++;
      continue;
    }

    used_b[t] = 1;  used_c++;
    next = data[t]-1;
    
    while(1)  {
      if(used_b[next]) break;
      used_b[next] = 1;
      used_c++;
      next = data[next]-1;
    }
    
    l++;
  }

  return l;
}

void permutate(int level)  {
  int i;
  if(level==num)  {
    used_c = 0;
    for(i=0;i<21;i++)  used_b[i] = 0;
    cycles[eval()]++;
    return;
  }
  for(i=1;i<=num;i++)  {
    if(used[i]) continue;
    used[i] = 1;
    data[level] = i;
    permutate(level+1);
    used[i] = 0;
  }
}

int main(void)  {
  int j;
  for(num=12;num<21;num++)  {
    for(j=0;j<21;j++) cycles[j] = 0;
    permutate(0);
    fp = fopen("perm12.gen", "a");
    for(j=1;j<=num;j++) fprintf(fp, "%lu ", cycles[j]);
    fprintf(fp, "\n");
    fclose(fp);    
  }
  return 0;
}
