{$I-,Q-,R-,S-,V-,X-}
const fin  = 'ots.inp';
      fout = 'ots.out';
      max = 10000; {}{}{}{}
type tpoint = record x, y : longint; end;
     line = record a,b : tpoint; end;
var f, f1 : text;
    n : word;
    ots : array[1..max] of line;


procedure Init;
  var tmp : tpoint;
  begin
    n := 0;
    fillchar(ots, sizeof(ots), 0);
    while not eof(f) do begin
      inc(n);
      readln(f,ots[n].a.x,ots[n].a.y,ots[n].b.x,ots[n].b.y);
      if ots[n].a.x > ots[n].b.x then begin
        tmp := ots[n].a;
        ots[n].a := ots[n].b;
        ots[n].b := tmp;
      end;
    end;
  end;

procedure swap(k1, k2:word);
  var tmp : line;
  begin
    tmp := ots[k1];
    ots[k1] := ots[k2];
    ots[k2] := tmp;
  end;

procedure qsort(left,right:word);
  var i, j, mid, w : word;
  begin
    {i:=left; j:=right; mid := (i+j) div 2;
    repeat
      while ots[i].a.x < ots[mid].a.x do inc(i);
      while ots[j].a.x > ots[mid].a.x do dec(j);
      if i<j then swap(i,j); inc(i); dec(j);
    until i>j;
    if i<right then qsort(i,right);
    if j>left then qsort(left,j);
} for i := 1 to right   do begin
   w := i;
   for j := i+1 to right do
     if ots[j].a.x < ots[w].a.x then w := j;
   if i<>w then swap(i,w);
  end;

  end;

procedure Solve;
  var i, j : word;
      broj : longint;

     function lize(aa,bb,cc : tpoint) : integer;
       var tmp : longint;
       begin
         tmp := (aa.x-bb.x)*(aa.y+bb.y)+(bb.x-cc.x)*(bb.y+cc.y)+(cc.x-aa.x)*(cc.y+aa.y);
         if tmp < 0 then lize := -1
         else if tmp > 0 then lize := 1
         else lize :=  0;
       end;

     function intersect(line1,line2 : line) : boolean;
       begin
        intersect := (lize(line1.a,line1.b,line2.a)*lize(line1.a,line1.b,line2.b) <= 0) and
          (lize(line2.a,line2.b,line1.a)*lize(line2.a,line2.b,line1.b) <= 0);
       end;

  begin
    broj:= 0;
    for i := 1 to n-1 do begin
      j := i+1;
      while ots[j].a.x <= ots[i].b.x do begin
        if intersect(ots[i],ots[j]) then inc(broj);
        inc(j);
        if j >n then break;
      end;
    end;
    writeln(f1, broj);
  end;


begin
  assign(f, fin); reset(f); assign(f1, fout); rewrite(f1);
  Init;
  Qsort(1,n);
  Solve;
  close(f); close(f1);
end.
