#include <stdio.h>
#include <mem.h>
#define MAX 1000001
#define MIN -1000001
#define min(a,b)  (((a)<(b))?(a):(b))
#define max(a,b)  (((a)>(b))?(a):(b))
////////////////////////////
struct HOD
{
 long x1,y1,x2,y2;
}*mas,*mymas;
long broi,mybroi,max=1024,mymax=1024;
long myx1=MAX,myx2=MAX,myy1=MAX,myy2=MAX;
////////////////////////////
void Add(long x1,long y1,long x2,long y2)
{if(broi==max)
 {
  HOD *tmp=new HOD[broi*2];
  max=broi*2;
  memcpy(tmp,mas,sizeof(HOD)*broi);
  delete mas;
  mas=tmp;
 }
 mas[broi].x1=x1;mas[broi].x2=x2;
 mas[broi].y1=y1;mas[broi].y2=y2;
 broi++;
}
////////////////
void AddMy(long x1,long y1,long x2,long y2)
{if(mybroi==mymax)
 {
  HOD *tmp=new HOD[mybroi*2];
  mymax=mybroi*2;
  memcpy(tmp,mymas,sizeof(HOD)*mybroi);
  delete mymas;
  mymas=tmp;
 }
 mymas[mybroi].x1=x1;mymas[mybroi].x2=x2;
 mymas[mybroi].y1=y1;mymas[mybroi].y2=y2;
 mybroi++;
}
////////////////
void input()
{long x1,x2,y1,y2;
 FILE *inp=fopen("TEMP","r");if(inp==NULL)return;
 mas=new HOD[1024];
 mymas=new HOD[1024];
 while(fscanf(inp,"%ld",&x1)!=EOF)
 {
  fscanf(inp,"%ld%ld%ld",&y1,&x2,&y2);
  Add(x1,y1,x2,y2);
  fscanf(inp,"%ld%ld%ld%ld",&x1,&y1,&x2,&y2);
  AddMy(x1,y1,x2,y2);
 }
 fclose(inp);
}
////////////////////////////
void EnterData(long x1,long y1,long x2,long y2)
{
 FILE *outp=fopen("TEMP","a");
 fprintf(outp,"%ld %ld %ld %ld\n",x1,y1,x2,y2);
 fclose(outp);
}
////////////////////////////
int Diff(HOD h1,HOD h2)
{
 long minx1,maxx1,miny1,maxy1;
 long minx2,maxx2,miny2,maxy2;
 minx1=min(h1.x1,h1.x2);
 maxx1=max(h1.x1,h1.x2);
 miny1=min(h1.y1,h1.y2);
 maxy1=max(h1.y1,h1.y2);
/////
 minx2=min(h2.x1,h2.x2);
 maxx2=max(h2.x1,h2.x2);
 miny2=min(h2.y1,h2.y2);
 maxy2=max(h2.y1,h2.y2);
/////
 if(minx1==minx2&&miny1==miny2&&maxx1==maxx2&&maxy1==maxy2)
   return 0;
 return 1;
}
///////////
int CheckIfPoss(long x1,long y1,long x2,long y2)
{long i,j;
 HOD tek;
//////////
 if(!(x1==x2||y1==y2)) return 0;
////////// 
 tek.x1=x1;tek.x2=x2;
 tek.y1=y1;tek.y2=y2;
 for(i=0;i<broi;i++)
  if(!Diff(tek,mas[i])) return 0;
 for(i=0;i<mybroi;i++)
  if(!Diff(tek,mymas[i])) return 0;
 return 1;
}
////////////////////////////
void FindHod()
{long i,j;
 for(i=0;i<broi;i++)
  for(j=i+1;j<broi;j++)
   {
    if(CheckIfPoss(mas[i].x1,mas[i].y1,mas[j].x1,mas[j].y1))
    {
     myx1=mas[i].x1;myy1=mas[i].y1;
     myx2=mas[j].x1;myy2=mas[j].y1;
     return;
    }
    if(CheckIfPoss(mas[i].x2,mas[i].y2,mas[j].x1,mas[j].y1))
    {
     myx1=mas[i].x2;myy1=mas[i].y2;
     myx2=mas[j].x1;myy2=mas[j].y1;
     return;
    }
    if(CheckIfPoss(mas[i].x1,mas[i].y1,mas[j].x2,mas[j].y2))
    {
     myx1=mas[i].x1;myy1=mas[i].y1;
     myx2=mas[j].x2;myy2=mas[j].y2;
     return;
    }
    if(CheckIfPoss(mas[i].x2,mas[i].y2,mas[j].x2,mas[j].y2))
    {
     myx1=mas[i].x2;myy1=mas[i].y2;
     myx2=mas[j].x2;myy2=mas[j].y2;
     return;
    }
   }
}
////////////////////////////
int Check(long x1,long y1)
{
 if(y1-1>MIN&&CheckIfPoss(x1,y1,x1,y1-1))
 {myx1=x1;myy1=y1;
  myx2=x1;myy2=y1-1;
  return 1;
 }
 if(y1+1<MAX&&CheckIfPoss(x1,y1,x1,y1+1))
 {myx1=x1;myy1=y1;
  myx2=x1;myy2=y1+1;
  return 1;
 }
 if(x1-1>MIN&&CheckIfPoss(x1,y1,x1-1,y1))
 {myx1=x1;myy1=y1;
  myx2=x1-1;myy2=y1;
 }
 if(x1+1<MAX&&CheckIfPoss(x1,y1,x1+1,y1))
 {myx1=x1;myy1=y1;
  myx2=x1+1;myy2=y1;
 }
}
////////////////////////////
void FindAlt()
{long i;
 for(i=0;i<broi;i++)
 {
  if(Check(mas[i].x1,mas[i].y1)) return;
  if(Check(mas[i].x2,mas[i].y2)) return;
 }
}
////////////////////////////
void main()
{long x1,y1,x2,y2;
 input();
 scanf("%ld%ld%ld%ld",&x1,&y1,&x2,&y2);
 EnterData(x1,y1,x2,y2);
 Add(x1,y1,x2,y2);
 FindHod();
 if(myx1==MAX)
  FindAlt();
 EnterData(myx1,myy1,myx2,myy2); 
 printf("%ld %ld %ld %ld",myx1,myy1,myx2,myy2);
 delete mas;
 delete mymas;
}
