#include <stdio.h>
#include <time.h>
#define INPF "ots.inp"
#define OUTF "ots.out"
#define MAXN 10000

struct Point {
               int x,y,pr;
             };

struct Ots   {
               Point p1,p2;
             } o[MAXN];

int n=0,res=0;

void Swap(Point *a,Point *b)
  {
    Point tmp=*a;
    *a=*b;
    *b=tmp;
  }

void Init()
  {
    FILE *f=fopen(INPF,"rt");
    while(!feof(f))
      {
        fscanf(f," %d %d %d %d ",&o[n].p1.x,&o[n].p1.y,&o[n].p2.x,&o[n].p2.y);
//        if(o[n].p1.x>o[n].p2.x) Swap(&o[n].p1,&o[n].p2);
        n++;
      }     
    fclose(f);
  }

int Lice(Point p1,Point p2,Point p3)
  {return (p1.x*p2.y+p1.y*p3.x+p2.x*p3.y-p1.x*p3.y-p1.y*p2.x-p2.y*p3.x);}

int Inter(Ots o1,Ots o2)
  {
/*    if(o1.p2.x<o2.p1.x) return 0;
    if(o2.p2.x<o1.p1.x) return 0;*/
    if(Lice(o2.p1,o2.p2,o1.p1)*Lice(o2.p1,o2.p2,o1.p2)<=0 &&
       Lice(o1.p1,o1.p2,o2.p1)*Lice(o1.p1,o1.p2,o2.p2)<=0) return 1;
    return 0;
  }

void Solve()
  {
    for(int i=0;i<n;i++)
      for(int j=0;j<i;j++)
        if(Inter(o[i],o[j])) res++;
  }

void Output()
  {
    FILE *f=fopen(OUTF,"wt");
    fprintf(f,"%d\n",res);
    fclose(f);
  }

void main()
  {
//    clock();
    Init();
    Solve();
    Output();
/*    for(int i=0;i<10000;i++)
      for(int j=0;j<i;j++);*/
//    printf("%0.2f\n",(float)clock()/CLOCKS_PER_SEC);
  }
