#include <stdio.h>
#define INPF "perm.inp"
#define OUTF "perm.out"
#define MAXN 30

int n,k;
double T[MAXN][MAXN]={0};

void Init()
  {
    FILE *f=fopen(INPF,"rt");
    fscanf(f,"%d%d",&n,&k);
    fclose(f);
  }

void Solve()
  {
    T[1][1]=1;
    for(int i=2;i<=n;i++)
      for(int j=1;j<=i;j++)
        T[i][j]=T[i-1][j-1]+T[i-1][j]*(i-1);
  }

void Output()
  {
    FILE *f=fopen(OUTF,"wt");
    fprintf(f,"%0.0lf\n",T[n][k]);
    fclose(f);
  }

int main()
  {  
    Init();
    Solve();
    Output();
  }
