const
 ifn = 'temp';
 ofn = '';
 maxm = 100;
 maxmv = 200000;
 max = 1000000;

type
 TMove =
  record
   x, y : longint;
   dir : shortint;
  end;

var
 t : text;
 mm : array [-20 .. maxm] of
  TMove;

 n, mn : longint;
 ms : array [1 .. maxmv] of
  TMove;

 cx, cy : longint;
 cdir : shortint;

procedure load;
begin
 assign (t, ifn);
 reset (t);
 while not eof (t) do
  begin
   inc (n);
   with ms[n] do
   readln (t, ms[n].x, ms[n].y, ms[n].dir);
  end;
 close (t);
end;

procedure calcy (ty : longint; var a, b : longint);
var
 i : longint;

begin
 for i := 1 to n do
  with ms[i] do
   if y < ty then
    inc (a)
   else
    if not ((y=ty) and (dir = 2)) then
     inc (b);
end;

procedure calcx (tx : longint; var a, b : longint);
var
 i : longint;

begin
 for i := 1 to n do
  with ms[i] do
   if x < tx then
    inc (a)
   else
    if not ((x = tx) and (dir = 1)) then
     inc (b);
end;

procedure swap (a, b : longint);
var
 c : longint;

begin
 c := a;
 a := b;
 b := c;
end;

function check (k : longint) : boolean;
var
 i : longint;

begin
 check := false;

 with mm[k] do
  begin
   if (cx = x) and (cy = y) and (cdir = dir) then exit;
   if (x < -max) or (x > max) or ((x = max) and (dir = 2)) then exit;
   if (y < -max) or (y > max) or ((y = max) and (dir = 1)) then exit;
   for i := 1 to n do
    if (ms[i].x = x) and (ms[i].y = y) and (ms[i].dir = dir) then
     exit;
  end;

 check := true;
end;

procedure genr (xx, yy : longint);
var
 dx, dy, dr, sg : longint;
begin
 for dx := 2 to 4 do
  for dy := 2 to 4 do
   for dr := 1 to 2 do
    for sg := -1 to 1 do
     if sg <> 0 then
      begin
       inc (mn);
       with mm[mn] do
        begin
         x := xx + sg*dx;
         y := yy + sg*dy;
         dir := dr;
        end;
      end;
end;

function findv (xx, yy : longint) : boolean;
var
 i : longint;

begin
 findv := true;
 i := 1;
 while i <= n do
  begin
   with ms[i] do
    begin
     if (xx = x) and (yy = y) then exit;
     if (xx = x) and (dir = 1) and (yy = y + 1) then exit;
     if (yy = y) and (dir = 2) and (xx = x + 1) then exit;
    end;
   inc (i, 2);
  end;
 findv := false;
end;

procedure work;
var
 xx, x1, x2, y1, y2 : longint;
 dir : shortint;
 st, i, res : longint;

 a, b : longint;

function first (xx, yy : longint) : boolean;
var
 dx, dy : longint;

begin
 for dx := -1 to 1 do
  for dy := -1 to 1 do
   if abs(dx) + abs(dy) = 1 then
    if findv (xx + dx, yy + dy) then
     begin
      dec (st);
      with mm[st] do
       begin
       if dx < 0 then
        begin
         x := xx + dx;
         y := yy;
         dir := 2;
        end
       else
        if dx > 0 then
         begin
          x := xx;
          y := yy;
          dir := 2;
         end;

       if dy < 0 then
        begin
         x := xx;
         y := yy + dy;
         dir := 1;
        end
       else
        if dy > 0 then
         begin
          x := xx;
          y := yy;
          dir := 1;
         end;

       end;

     end;
end;

begin
 readln (x1, y1, x2, y2); {!!!}
 a := 0;
 b := 0;
 if x1 <> x2 then
  begin
   dir := 2;
   calcy (y1, a, b);
   if x1 > x2 then
    swap (x1, x2);
  end;

 if y1 <> y2 then
  begin
   dir := 1;
   calcx (x1, a, b);
   if y1 > y2 then swap (y1, y2);
  end;

 cdir := dir;
 cx := x1;
 cy := y1;

 res := b - a;
 if res < 0 then
  res := 1
 else
  res := 0;

 st := 1;
 first (x1, y1);
 first (x2, y2);
 mn := 6;
 if abs (dir) = 1 then
  begin
   mm[1].x := x2 - res;
   mm[1].y := y2;
   mm[1].dir := 2;

   mm[2].x := x1 - res;
   mm[2].y := y1;
   mm[2].dir := 2;

   if res = 0 then
    res := 1
   else
    res := 0;

   mm[3].x := x2 - res;
   mm[3].y := y2;
   mm[3].dir := 2;

   mm[4].x := x1 - res;
   mm[4].y := y1;
   mm[4].dir := 2;

   mm[5].x := x2;
   mm[5].y := y2;
   mm[5].dir := 1;

   mm[6].x := x1;
   mm[6].y := y1-1;
   mm[6].dir := 1;

  end
 else
  begin
   mm[1].x := x2;
   mm[1].y := y2 - res;
   mm[1].dir := 1;

   mm[2].x := x1;
   mm[2].y := y1 - res;
   mm[2].dir := 1;

   if res = 0 then
    res := 1
   else
    res := 0;

   mm[3].x := x2;
   mm[3].y := y2 - res;
   mm[3].dir := 1;

   mm[4].x := x1;
   mm[4].y := y1 - res;
   mm[4].dir := 1;

   mm[5].x := x2;
   mm[5].y := y2;
   mm[5].dir := 2;

   mm[6].x := x1-1;
   mm[6].y := y1;
   mm[6].dir := 2;

  end;
 mn := 6;
 genr (x2, y2);
 i := st;
 repeat
  inc (I);
 until check (i);


 write (mm[i].x, ' ', mm[i].y, ' ');
 if mm[i].dir = 1 then
  writeln (mm[i].x, ' ', mm[i].y+1)
 else
  writeln (mm[i].x+1, ' ', mm[i].y);

 ms[n+1].x := x1;
 ms[n+1].y := y1;
 ms[n+1].dir := dir;

 ms[n+2].x := mm[i].x;
 ms[n+2].y := mm[i].y;
 ms[n+2].dir := mm[i].dir;
 assign (t, ifn);
 rewrite (t);
 for i := 1 to n do
  begin
 writeln(t, ms[i].x, ' ',ms[i].y, ' ', ms[i].dir);
  end;
 close (t);
end;

procedure output;
begin
 assign (t, ofn);
 rewrite (t);
 close (t);
end;

begin
 load;
 work;
end.