const
 ifn = 'perm.inp';
 ofn = 'perm.out';
 maxn = 24;
 sd = 2;
 dd = 7;
 maxl = 1000;
 bs = 10;

type
 BNum =
  record
   l : longint;
   d : array [1 .. maxl] of integer;
  end;

var
 t : text;
 p, st : array [1 .. maxn] of longint;
 kk, ans, n, k, stt : longint;
 vs : array [1 .. maxn] of boolean;
 dyn : array [0 .. maxn, 0 .. maxn] of Bnum;
 i, j : longint;
 tm : Bnum;

 a, b : Bnum;

procedure input;
begin
 assign (t, ifn);
 reset (t);
 readln (t, n, k);
 close (t);
end;

function check : boolean;
var vl, st, i : longint;

begin
 check := false;
 vl := 0;
 fillchar (vs, sizeof(vs), 0);
 for st := 1 to n do
  if not vs[st] then
   begin
    i := st;
    inc (vl);
    if vl > k then exit;
    repeat
     vs[i] := true;
     i := p[i];
    until i = st;
   end;

 check := vl = k;
end;

procedure perm (cl, l : longint);
var
 i, k : longint;

begin
 if cl > kk then
  exit;
 if l > n then
  begin
   if check then
    inc (ans);
   exit;
  end;

 for i := 1 to stt do
  begin
   k := st[i];
   st[i] := st[stt];
   dec (stt);
   p[l] := k;
   if p[l] = l then
    perm (cl+1, l+1)
   else
    perm (cl, l+1);

   inc (stt);
   st[stt]:=st[i];
   st[i] := k;
  end;
end;

procedure initst;
var
 i : longint;

begin
 stt := n;
 for i := 1 to stt do
  st[i] := i;
end;

function max (a, b: longint) : longint;
begin
 max := a;
 if b > a then
  max := b;
end;

procedure badd (var a, b: BNum);
var
 i, c : longint;

begin
 c := 0;
 a.l := max(a.l, B.l);
 for i := 1 to a.l do
  begin
   c := c + a.d[i] + b.d[i];
   a.d[i] := c mod bs;
   c := c div bs;
  end;
 while c > 0 do
  begin
   inc (a.l);
   a.d[a.l] := c mod bs;
   c := c div bs;
  end;

end;

procedure bmul (var a : Bnum; x : longint);
var
 i, c : longint;

begin
 c := 0;
 for i := 1 to a.l do
  begin
   c := c + a.d[i]*x;
   a.d[i] := c mod 10;
   c := c div 10;
  end;

 while c > 0 do
  begin
   inc (a.l);
   a.d[a.l] := c mod 10;
   c := c div 10;
  end;

end;

procedure bshow (var b : Bnum);
begin
 for i := b.l downto 1 do
  write (t, b.d[i]);
 writeln (t);
end;

procedure getbnum (var a : Bnum);
var s : string;
begin
 readln (t, s);
 a.l := length (s);
 for i := a.l downto 1 do
  a.d[i] := ord(s[a.l-i+1]) - ord('0');
end;

procedure output;
begin
 assign (t, ofn);
 rewrite (t);
 bshow (dyn[n,k]);
 close (t);
end;

begin
 input;
 dyn[1,1].l := 1;
 dyn[1,1].d[1] := 1;
 for i := 2 to n do
   for j := 1 to k do
    begin
     badd (dyn[i,j], dyn[i-1, j-1]);
     tm := dyn[i-1, j];
     bmul (tm, i-1);
     badd (dyn[i,j], tm);
    end;
 output;
{
 assign (t, 'infile.txt');
 reset (T);
 getbnum (a);
 getbnum (B);
 close (t);
 assign (t, ofn);
 rewrite (t);
 badd (a, b);
 bshow (a);
 bmul (a, 11);
 bshow (a);
 close (T);
 }
end.