#include <fstream.h>
#define max(a, b) ((a) > (b) ? (a) : (b))
#define min(a, b) ((a) < (b) ? (a) : (b))

  ifstream fin ("ots.inp");
  ofstream fout ("ots.out");

  struct TPoint
    {
      long long x, y;
    };

  struct TOts
    {
      TPoint A, B;
    };

  TOts A[10010];
  long long n = -1;

  void ReadData ()
    {
      long long q, w, e, r;
      q = 1;
      while (q != -1)
        {
          q = -1;
          fin >> q >> w >> e >> r;
          if (q != -1)
            {
              n++;
              A[n].A.x = q;
              A[n].A.y = w;
              A[n].B.x = e;
              A[n].B.y = r;
            }
        }
    }

  int orient (TPoint &a, TPoint &b, TPoint &c)
    {
      long long k = (b.x - a.x)*(c.y - a.y) - (b.y - a.y)*(c.x - a.x);
      if (k < 0) return -1; if (k == 0) return 0; if (k > 0) return 1;
    }

  int Check (TOts &a, TOts &b)
    {
      if ((min (b.A.x, b.B.x) <= max (a.A.x, a.B.x)) && (min (a.A.x, a.B.x) <= max (b.A.x, b.B.x)) && (min (b.A.y, b.B.y) <= max (a.A.y, a.B.y)) && (min (a.A.y, a.B.y) <= max (b.A.y, b.B.y)))
        if ((orient (a.A, a.B, b.A)*orient (a.A, a.B, b.B) <= 0) && (orient (b.A, b.B, a.A)*orient (b.A, b.B, a.B) <= 0))
          return true;
      return false;
    }

  long Solve ()
    {
      int br = 0;
      for (int i = 0; i <= n; i++)
        for (int j = i + 1; j <= n; j++)
          {
            if (Check (A[i], A[j]))
              br++;
          }
      return br;
    }

  int main ()
    {
      ReadData ();
      fout << Solve ();
    }
