#include <fstream.h>
struct point { unsigned int x, y; };

unsigned int ABC(const point& a, const point& b, const point& c)
{
 return (a.y - b.y)*c.x + (b.x - a.x)*c.y + (a.x*b.y - b.x*a.y);
}

int main()
{
 ifstream fin("ots.inp");
 ofstream fout("ots.out");

 point a[10001];
 point b[10001];

 int n = 0;
 while (fin)
  {
   n++;
   fin >> a[n].x >> a[n].y >> b[n].x >> b[n].y;
  }
 n--;

 unsigned long int Count = 0; int p1 = 0; int p2 = 0; int q1 = 0; int q2 = 0; int i =0; int j = 0;
 for (i = 1; i <= n; i++)
  for (j = i+1; j <= n; j++)
   {
    int p1 = ABC(a[i], b[i], a[j]);
    int p2 = ABC(a[i], b[i], b[j]);
    int q1 = ABC(a[j], b[j], a[i]);
    int q2 = ABC(a[j], b[j], b[i]);

    if ((p1 == 0 && p2 == 0) || (q1 == 0 && q2 == 0))
     { Count++; continue; }
    if ((p1 >= 0 && p2 <= 0) || (p1 <= 0 && p2 >= 0))
     if ((q1 >= 0 && q2 <= 0) || (q1 <= 0 && q2 >= 0))
      Count++;
   }

 fout << Count;
 return 0;
}