type
  TRes=record min, t, st: Integer; end;

var F: array[1..300, 1..300, 0..1] of TRes;
    N, st: Integer;
    m, tmp: TRes;
    P: array[1..300] of Integer;
    R: array[1..300] of Integer;
    fout: Text;

function razst(a, b: Integer): Integer;
begin
  razst:=abs(R[a]-R[b]);
end;

function min(a, b: Integer): Integer;
begin
  if a<b then min:=a
  else min:=b;
end;

function Rec(l, r, u: Integer): TRes;
var r1, r2: Integer; x1, x2, res: TRes;
begin
  res.min:=0;
  res.t:=0;
  res.st:=l;
  if l=r then begin Rec:=res; exit; end;
  if u=0 then
    begin
    if F[l+1, r, 0].t=0 then
      x1:=Rec(l+1, r, 0)
    else
      x1:=F[l+1, r, 0];
    if F[l+1, r, 1].t=0 then
      x2:=Rec(l+1, r, 1)
    else
      x2:=F[l+1, r, 1];
    r1:=x1.min+razst(l, l+1)*P[l]+P[l]*x1.t;
    r2:=x2.min+razst(l, r)*P[l]+P[l]*x2.t;
    if r1<r2 then
      begin
      res.min:=r1;
      res.t:=razst(l, l+1)+x1.t;
      res.st:=x1.st;
      end
    else
      begin
      res.min:=r2;
      res.t:=razst(l, r)+x2.t;
      res.st:=x2.st;
      end;
    end
  else
    begin
    if F[l, r-1, 1].t=0 then
      x1:=Rec(l, r-1, 1)
    else
      x1:=F[l, r-1, 1];
    if F[l, r-1, 0].t=0 then
      x2:=Rec(l, r-1, 0)
    else
      x2:=F[l, r-1, 0];
    r1:=x1.min+razst(r, r-1)*P[r]+P[r]*x1.t;
    r2:=x2.min+razst(l, r)*P[r]+P[r]*x2.t;
    if r1<r2 then
      begin
      res.min:=r1;
      res.t:=razst(r, r-1)+x1.t;
      res.st:=x1.st;
      end
    else
      begin
      res.min:=r2;
      res.t:=razst(l, r)+x2.t;
      res.st:=x2.st;
      end;
    end;
  F[l, r, u]:=res;
  Rec:=res;
end;

procedure ReadData(fname: string);
var F: Text; i: Integer;
begin
  Assign(F, fname);
  Reset(F);
  Readln(F, N);
  for i:=1 to N do
    begin
    readln(F, R[i], P[i]);
    end;
  Close(F);
end;

begin
  ReadData('drain.inp');
  m:=Rec(1, N, 0);
  tmp:=Rec(1, N, 1);
  if m.min>tmp.min then
    m:=tmp;
  Assign(fout, 'drain.out');
  Rewrite(fout);
  writeln(fout, m.min);
  writeln(fout, m.st);
  Close(fout);
end.
