{$MODE objfpc}

Var
  XSize, YSize : Integer;
  mode : Integer;
  tbl : Array[1..16, 1..16] Of Integer;
  mode1cnt : Integer;
  mode1Y : Array[1..300] Of Integer;
  mode1X : Array[1..300] Of Integer;
  mode2cnt : Integer;
  mode2Y1 : Array[1..300] Of Integer;
  mode2X1 : Array[1..300] Of Integer;
  mode2Y2 : Array[1..300] Of Integer;
  mode2X2 : Array[1..300] Of Integer;
  zero : Boolean;
  p : Integer;
  lft : Integer;
  ttq, ok : Boolean;
  tstart : Word;
  tout : Integer;

Procedure QQ(Q : Integer);

Var
  X, Y : Integer;
  done1, done2, done3, done4 : Boolean;

Begin
  If (Word(MemW[$46C] - tstart)) > tout Then
    ttq := True;
  If ttq Then
    Exit;
  If lft = 0 Then
  Begin
    ttq := True;
    ok := True;
  End;
  done1 := False;
  done2 := False;
  done3 := False;
  done4 := False;
  For Y := 1 To YSize - 1 Do
    For X := 1 To XSize - 1 Do
    Begin
      {
      XX
      X
      }
      If ((Tbl[X, Y] + Tbl[X + 1, Y] + Tbl[X, Y + 1]) = 0) And (Not done1) Then
      Begin
        Tbl[X, Y] := Q;
        Tbl[X + 1, Y] := Q;
        Tbl[X, Y + 1] := Q;
        Dec(lft, 3);
        QQ(Q + 1);
        Inc(lft, 3);
        Tbl[X, Y] := 0;
        Tbl[X + 1, Y] := 0;
        Tbl[X, Y + 1] := 0;
        done1 := True;
      End;
      {
       X
      XX
      }
      If ((Tbl[X + 1, Y + 1] + Tbl[X + 1, Y] + Tbl[X, Y + 1]) = 0) And (Not done2) Then
      Begin
        Tbl[X + 1, Y + 1] := Q;
        Tbl[X + 1, Y] := Q;
        Tbl[X, Y + 1] := Q;
        Dec(lft, 3);
        QQ(Q + 1);
        Inc(lft, 3);
        Tbl[X + 1, Y + 1] := 0;
        Tbl[X + 1, Y] := 0;
        Tbl[X, Y + 1] := 0;
        done2 := True;
      End;
      {
      X
      XX
      }
      If ((Tbl[X + 1, Y + 1] + Tbl[X, Y] + Tbl[X, Y + 1]) = 0) And (Not done3) Then
      Begin
        Tbl[X + 1, Y + 1] := Q;
        Tbl[X, Y] := Q;
        Tbl[X, Y + 1] := Q;
        Dec(lft, 3);
        QQ(Q + 1);
        Inc(lft, 3);
        Tbl[X + 1, Y + 1] := 0;
        Tbl[X, Y] := 0;
        Tbl[X, Y + 1] := 0;
        done3 := True;
      End;
      {
      XX
       X
      }
      If ((Tbl[X + 1, Y + 1] + Tbl[X, Y] + Tbl[X + 1, Y]) = 0) And (Not done4) Then
      Begin
        Tbl[X + 1, Y + 1] := Q;
        Tbl[X, Y] := Q;
        Tbl[X + 1, Y] := Q;
        Dec(lft, 3);
        QQ(Q + 1);
        Inc(lft, 3);
        Tbl[X + 1, Y + 1] := 0;
        Tbl[X, Y] := 0;
        Tbl[X + 1, Y] := 0;
        done4 := True;
      End;
    End;
End;

Function Test(X, Y : Integer) : Boolean;

Begin
  ttq := False;
  ok := False;

  tstart := MemW[$46C];
  FillChar(Tbl, SizeOf(Tbl), 0);
  Tbl[X, Y] := 99;
  lft := (XSize * YSize Div 3) * 3;
  QQ(1);
{  If ok Then
    Writeln(Word(MemW[$46C] - tstart));}
  Test := ok;
End;

Function Test2(X1, Y1, X2, Y2 : Integer) : Boolean;

Begin
  ttq := False;
  ok := False;

  tstart := MemW[$46C];
  FillChar(Tbl, SizeOf(Tbl), 0);
  Tbl[X1, Y1] := 99;
  Tbl[X2, Y2] := 99;
  lft := (XSize * YSize Div 3) * 3;
  QQ(1);
{  If ok Then
    Writeln(Word(MemW[$46C] - tstart));}
  Test2 := ok;
End;

Function TestH(X, Y : Integer) : Boolean;

Begin
  TestH := Test2(X, Y, X + 1, Y);
End;

Function TestV(X, Y : Integer) : Boolean;

Begin
  TestV := Test2(X, Y, X, Y + 1);
End;

Procedure Fill3even(X1, Y1, X2, Y2 : Integer);

Var
  X, Y : Integer;

Begin
  If X2 < X1 Then
    Exit;
  If Y2 < Y1 Then
    Exit;
  If ((((X2 - X1) + 1) Mod 3) = 0) And ((((Y2 - Y1) + 1) Mod 2) = 0) Then
  Begin
    For Y := Y1 To Y2 Do
    Begin
      If ((Y - Y1) And 1) <> 0 Then
        Continue;
      X := X1;
      While X < X2 Do
      Begin
        Inc(p);
        Tbl[X, Y] := p;
        Tbl[X + 1, Y] := p;
        Tbl[X, Y + 1] := p;
        Inc(p);
        Tbl[X + 1, Y + 1] := p;
        Tbl[X + 2, Y] := p;
        Tbl[X + 2, Y + 1] := p;
        Inc(X, 3);
      End;
    End;
  End
  Else
  Begin
    For X := X1 To X2 Do
    Begin
      If ((X - X1) And 1) <> 0 Then
        Continue;
      Y := Y1;
      While Y < Y2 Do
      Begin
        Inc(p);
        Tbl[X, Y] := p;
        Tbl[X, Y + 1] := p;
        Tbl[X + 1, Y] := p;
        Inc(p);
        Tbl[X + 1, Y + 1] := p;
        Tbl[X, Y + 2] := p;
        Tbl[X + 1, Y + 2] := p;
        Inc(Y, 3);
      End;
    End;
  End;
End;

Procedure WriteOut;

Var
  F : Text;
  X, Y : Integer;
  I : Integer;

Begin
  ASSign(F, 'BOARD.OUT');
  Rewrite(F);
  If zero Then
  Begin
    Writeln(F, 0);
  End
  Else
  Begin
    Case mode Of
      0 : For Y := 1 To YSize Do
      Begin
        For X := 1 To XSize Do
          Write(F, tbl[X, Y]:3);
        Writeln(F);
      End;
      1 : Begin
        Writeln(F, mode1cnt);
        For I := 1 To mode1cnt Do
          Writeln(F, mode1Y[I], ' ', mode1X[I]);
      End;
      2 : Begin
        Writeln(F, mode2cnt);
        For I := 1 To mode2cnt Do
          Writeln(F, mode2Y1[I], ' ', mode2X1[I], ' ', mode2Y2[I], ' ', mode2X2[I]);
      End;
    End;
  End;
  Close(F);
  Halt;
End;

Procedure WriteOutZero;

Begin
  zero := True;
  WriteOut;
End;

Procedure ReadIn;

Var
  F : Text;

Begin
  ASSign(F, 'BOARD.INP');
  Reset(F);
  Readln(F, YSize, XSize);
  mode := (XSize * YSize) Mod 3;
  Close(F);
  zero := False;
  p := 0;
End;

Var
  X, Y : Integer;
  XMax, YMax, XMax1, YMax1, XMax2, YMax2 : Integer;

Begin
  ReadIn;
  mode1cnt := 0;
  tout := Round(162/((XSize * YSize)/4));
  Case mode Of
    0 : Begin
      If (XSize < 2) Or (YSize < 2) Then
        WriteOutZero;
      If (XSize Mod 3) = 0 Then
      Begin
        If (YSize Mod 2) = 0 Then
        Begin
          Fill3even(1, 1, XSize, YSize);
          WriteOut;
        End
        Else
        Begin
          If (XSize Mod 2) <> 0 Then
            WriteOutZero;
          Fill3even(1, 1, XSize, 3);
          Fill3even(1, 4, XSize, YSize);
          WriteOut;
        End;
      End
      Else
      Begin
        If (XSize Mod 2) = 0 Then
        Begin
          Fill3even(1, 1, XSize, YSize);
          WriteOut;
        End
        Else
        Begin
          If (YSize Mod 2) <> 0 Then
            WriteOutZero;
          Fill3even(1, 1, 3, YSize);
          Fill3even(4, 1, XSize, YSize);
          WriteOut;
        End;
      End;
    End;
    1 : Begin
      If ((XSize = 1) And (YSize = 1)) Or
         ((XSize = 2) And (YSize = 2)) Then
      Begin
        mode1cnt := 1;
        mode1Y[mode1cnt] := 1;
        mode1X[mode1cnt] := 1;
        WriteOut;
      End;
      If (XSize = 1) Or (YSize = 1) Then
      Begin
        mode1cnt := 0;
        WriteOut;
      End;
      mode1cnt := 0;
      YMax := (YSize + 1) Div 2;
      XMax := (XSize + 1) Div 2;
      For Y := 1 To YMax Do
        For X := 1 To XMax Do
        Begin
          If XSize = YSize Then
          Begin
            If X < Y Then
              Continue;
          End;
          If Test(X, Y) Then
          Begin
            Inc(mode1cnt);
            mode1Y[mode1cnt] := Y;
            mode1X[mode1cnt] := X;
          End;
        End;
      WriteOut;
    End;
    2 : Begin
      mode2cnt := 0;
      YMax := (YSize + 1) Div 2;
      XMax := (XSize + 1) Div 2;
      YMax1 := (YSize + 1) Div 2;
      XMax1 := (XSize) Div 2;
      YMax2 := (YSize) Div 2;
      XMax2 := (XSize + 1) Div 2;
      For Y := 1 To YMax Do
        For X := 1 To XMax Do
        Begin
          If (X <= XMax1) And (Y <= YMax1) And TestH(X, Y) Then
          Begin
            Inc(mode2cnt);
            mode2X1[mode2cnt] := X;
            mode2Y1[mode2cnt] := Y;
            mode2X2[mode2cnt] := X + 1;
            mode2Y2[mode2cnt] := Y;
          End;
          If XSize <> YSize Then
          Begin
            If (X <= XMax2) And (Y <= YMax2) And TestV(X, Y) Then
            Begin
              Inc(mode2cnt);
              mode2X1[mode2cnt] := X;
              mode2Y1[mode2cnt] := Y;
              mode2X2[mode2cnt] := X;
              mode2Y2[mode2cnt] := Y + 1;
            End;
          End;
        End;
(*      If XSize <> YSize Then
      Begin
        For Y := 1 To YMax Do
          For X := 1 To XMax Do
          Begin
            If TestV(X, Y) Then
            Begin
{              Writeln(X, ' ', Y);}
              Inc(mode2cnt);
              mode2X1[mode2cnt] := X;
              mode2Y1[mode2cnt] := Y;
              mode2X2[mode2cnt] := X;
              mode2Y2[mode2cnt] := Y + 1;
            End;
          End;
      End;*)
      WriteOut;
    End;
  End;
End.
