const inp = 'board.inp';
      out = 'board.out';

type TBoard = array[1..15, 1..15]of byte;

var Fin, Fout: Text;
    m, n: byte;
    board: TBoard;

{############################################################################}
Procedure Done;
begin
close(Fin); close(Fout);
halt;
end;

{############################################################################}
Procedure Init;

begin
assign(Fin, inp); reset(Fin);
assign(Fout, out); rewrite(Fout);
readln(Fin, m, n);
end;

{############################################################################}
procedure Print;
var max, k, i, j: byte;
    space: array[1..15]of byte;

begin
fillchar(space, sizeof(space), 0);
for i:=1 to n do
  begin
  max:= 1;
  for j:=1 to m do
    if board[j,i] > 9 then begin max:=2; break; end;
  space[i]:= max;
  end;
for i:=1 to m do
  begin
  for j:=1 to n do
    if (space[j] = 1)or(board[i,j]>9) then write(Fout, ' ', board[i,j])
    else write(Fout, '  ', board[i,j]);
  writeln(Fout);
  end;
Done;
end;

{############################################################################}
Procedure Solve0;
var k, i, j: byte;

begin
if (m < 1) or (n < 2) or odd(m*n) then
  begin
  writeln(Fout, 0);
  Done;
  end;

if (not odd(n))and(m mod 3 = 0) then
  begin
  for i:= 1 to m div 3 do
    for j:= 1 to n div 2 do
      begin
      k:= (i-1)*(n div 2)*2 + (j-1)*2 + 1;
      board[i*3 - 2, j*2 - 1]:= k;
      board[i*3 - 2, j*2]:= k;
      board[i*3 - 1, j*2 - 1]:= k;
      board[i*3 - 1, j*2]:= k+1;
      board[i*3, j*2 - 1]:= k+1;
      board[i*3, j*2]:= k+1;
      end;
  Print;
  end;

if (not odd(m))and(n mod 3 = 0) then
  begin
  for i:= 1 to m div 2 do
    for j:= 1 to n div 3 do
      begin
      k:= (i-1)*(n div 3)*2 + (j-1)*2 + 1;
      board[i*2 - 1, j*3 - 2]:= k;
      board[i*2 - 1, j*3 - 1]:= k;
      board[i*2 - 1, j*3]:= k+1;
      board[i*2, j*3 - 2]:= k;
      board[i*2, j*3 - 1]:= k+1;
      board[i*2, j*3]:= k+1;
      end;
  Print;
  end;

writeln(Fout, 0);
Done;
end;

{############################################################################}
{############################################################################}
{############################################################################}
{############################################################################}
BEGIN
Init;
case (m*n mod 3) of
  0: Solve0;
  1: writeln(Fout, 0);
  2: writeln(Fout, 0);
  end;
Done;
END.
