const inp = 'drain.inp';
      out = 'drain.out';
      MaxN = 300;

type TDist = Array[1..MaxN]of integer;
     TDeb = array[1..MaxN]of longint;
     TR = record
          a, b: integer;
          end;
     TRast = array[1..MaxN, 1..MaxN]of TR;

var Fin, Fout: Text;
    n, bestS: integer;
    dist: TDist;
    deb: TDeb;
    bestLoss: longint;
    rast: TRast;

{############################################################################}
Procedure Done;
begin
close(Fin); close(Fout);
halt;
end;

{############################################################################}
Procedure SetOff;
var i, max, min: integer;

begin
assign(Fin, inp); reset(Fin);
assign(Fout, out); rewrite(Fout);
readln(Fin, n);

max:= -1; min:= MaxInt;
for i:=1 to n do
  begin
  readln(Fin, dist[i], deb[i]);
  if max < dist[i] then max:= dist[i];
  if min > dist[i] then min:= dist[i];
  end;
for i:=1 to n do dec(dist[i], min);

bestS:= 0;
bestLoss:= maxLongInt;
end;

{############################################################################}
Procedure Atempt;
var S, i, j: integer;
    loss: longint;

begin
for i:=1 to n-1 do
  for j:=i+1 to n do
    begin
    rast[i,j].a:= dist[j] - dist[i];
    rast[i,j].b:= dist[i]+ dist[j];
    rast[j,i].a:= dist[j] - dist[i];
    rast[j,i].b:= dist[n] - dist[i]+ dist[n] - dist[j];
    end;

for s:=1 to n do
  begin
  loss:= 0;
  for i:=1 to s-1 do inc(loss, deb[i]*rast[s,i].a);
  if loss > bestLoss then continue;
  for i:=s+1 to n do inc(loss, deb[i]*rast[s,i].b);
  if loss < bestLoss then
    begin bestS:= s; bestLoss:= loss; end;

  loss:= 0;
  for i:=1 to s-1 do inc(loss, deb[i]*rast[s,i].b);
  if loss > bestLoss then continue;
  for i:=s+1 to n do inc(loss, deb[i]*rast[s,i].a);
  if loss < bestLoss then
    begin bestS:= s; bestLoss:= loss; end;
  end;

writeln(Fout, bestLoss);
writeln(Fout, bestS);
end;

{############################################################################}
{############################################################################}
{############################################################################}
BEGIN
SetOff;
Atempt;
Done;
END.
