#include <stdio.h>
#include <stdlib.h>
#define INPF "board.inp"
#define OUTF "board.out"
#define MAXM 20
#define MAXN 20
#define MAXK 100

short gr[MAXM][MAXN]={0};
int m,n,br=0;
int prx,pry;
int prxs[MAXN];
int prys[MAXN];
int count;

void Init()
  {
    FILE *f=fopen(INPF,"rt");
    fscanf(f,"%d%d",&m,&n);
    fclose(f);
  }

void Output()
  {
    if(br==m*n)
      {
	if(m*n%3==0)
	  {
	    FILE *f=fopen(OUTF,"wt");
	    for(int i=0;i<m;i++)
	      {
		for(int j=0;j<n;j++)
		  fprintf(f,"%d ",gr[i][j]);
		fprintf(f,"\n");
	      }
	    fclose(f);
	    exit(0);
	  }
	if(m*n%3==1)
	  {
	    prxs[count]=prx;
	    prxs[count++]=pry;
	  }
      }
  }

void Find(int x,int y,int k)
  {
/*    if(x==m-1 && y==n-1) return;
    if(gr[x][y])for(int i=0;i<n;i++) if(!gr[x][i]) break;
    if(y==n-1)
      for(int i=0;i<m;i++)
	if(!gr[y+1][i]) {Find(y+1,i,k);break;}*/
    if(!gr[x][y])
      {
	if(x+1<m && !gr[x+1][y] && y+1<n && !gr[x+1][y+1])
	  {
	    gr[x][y]=gr[x+1][y]=gr[x+1][y+1]=k;br+=3;
	    Output();
	    for(int i=x;i<m;i++)
	      for(int j=0;j<n;j++)
		if(!gr[i][j]) {Find(i,j,k+1);break;}
/*	    Find(x,y+1,k+1);
	    if(y+2<n) Find(x+1,y+2,k+1);*/
	    gr[x][y]=gr[x+1][y]=gr[x+1][y+1]=0;br-=3;
	  }
	if(y+1<n && !gr[x][y+1])
	  {
	    if(x+1<m && !gr[x+1][y+1])
	      {
		gr[x][y]=gr[x][y+1]=gr[x+1][y+1]=k;br+=3;
		Output();
	    for(int i=x;i<m;i++)
	      for(int j=0;j<n;j++)
		if(!gr[i][j]) {Find(i,j,k+1);break;}
/*		if(y+2<n)
		  {
		    Find(x,y+2,k+1);
		    Find(x+1,y+2,k+1);
		  }
		else
		  {
		    for(int i=0;i<n;i++)
		      if(!gr[x+1][i]) {Find(x+1,i,k+1);break;}
		  }*/
		gr[x][y]=gr[x][y+1]=gr[x+1][y+1]=0;br-=3;
	      }
	    if(x+1<m && y+1<n && !gr[x][y+1] && !gr[x+1][y])
	      {
		gr[x][y]=gr[x][y+1]=gr[x+1][y]=k;br+=3;
		Output();
	    for(int i=x;i<m;i++)
	      for(int j=0;j<n;j++)
		if(!gr[i][j]) {Find(i,j,k+1);break;}
/*		if(y+2<n) Find(x,y+2,k+1);
		Find(x+1,y+1,k+1);*/
		gr[x][y]=gr[x][y+1]=gr[x+1][y]=0;br-=3;
	      }
	  }
      }
  }


int main()
  {
    Init();
    if(m*n%3==0)
      {
	Find(0,0,1);
	FILE *f=fopen(OUTF,"wt");
	fprintf(f,"0\n");
	fclose(f);
      }
    if(m*n%3==1)
      {
	for(prx=0;prx<m;prx++)
	  for(pry=prx+1;pry<n;pry++)
	    {
	      gr[prx][pry]=MAXK-1;
	      Find(0,0,1);
	      gr[prx][pry]=0;
	    }
	      FILE *f=fopen(OUTF,"wt");
	      fprintf(f,"%d\n",count);
	      for(int i=0;i<count;i++)
		fprintf(f,"%d %d\n",prxs[i]+1,prys[i]+1);
	      fclose(f);
      }
    return 0;
  }