#include <stdio.h>

#define NOEDGE	-123456

int n, m;

int adj[1000][1000];
int deg[1000];
int time[1000];
int processed[1000];
int ptr = 0;

int main() {
    int found, i, j, c, t;
	FILE *f;

    for (i = 0; i < 1000; i++)
    	for (j = 0; j < 1000; j++)
        	adj[i][j] = NOEDGE;

    for (i = 0; i < n; i++)
    	time[i] = 0;

    f = fopen("work.inp", "rt");
    fscanf(f, "%i %i", &n, &m);
    for (t = 0; t < m; t++) {
    	fscanf(f, "%i %i %i", &i, &j, &c);
        if (c > 0)
	        adj[j-1][i-1] = -c;
        else {
            adj[i-1][j-1] = -c;
            deg[j-1]++;
        }
    }
    fclose(f);

      while (ptr < n) {
        found = 0;
    	for (i = 0; i < n; i++)
	    	if (!deg[i]) {
                found = 1;
            	deg[i] = -1;
                processed[ptr++] = i;
                for (j = 0; j< n; j++)
                	if (adj[i][j] >= 0) {
                        deg[j]--;
                        if (time[i] + adj[i][j] > time[j])
                           time[j] = time[i] + adj[i][j];
                    	adj[i][j] = NOEDGE;
                    }

            }
      if (!found) {
         f = fopen("work.out", "wt");
         fprintf(f, "NO SOLUTION\n");
         fclose(f);
         return 0;
      }
    }

    f = fopen("work.out", "wt");
    for (i = 0; i < n; i++)
        fprintf(f, "%i\n", time[i]);
    fclose(f);
    return 0;
}
