#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>


#define MAXN 16

int g[MAXN][MAXN];
int g1[MAXN][MAXN];
int tocheck[MAXN][MAXN];
int tocheck1[MAXN][MAXN];
int Y, X;
int casea, caseb, casec;
int trans;
int P;


void read_all(void);
void do_all(void);
void solvea(void);
void solveb(void);
void solvec(void);
int bt(int y, int x);
void write_all(void);



int main(void)
{
  int i, j, t;
  
  freopen("board.inp", "rt", stdin);
  freopen("board.out", "wt", stdout);
  read_all();
/*  for (i = 0; i <= 15; i++) {
    for (j = 0; j <= 15; j++) {
      Y = i;
      X = j;
      t = clock();
      do_all();
      t = clock()-t;
      if (t >= CLOCKS_PER_SEC/3) {
        printf("%.2lf\n", 1.*t/CLOCKS_PER_SEC);
      }
    }
  }
  return 0;*/
/*  while (scanf("%d %d", &Y, &X) == 2) {
    P = 0;
    casea = caseb = casec = 0;
    do_all();
    write_all();
  }*/
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  scanf("%d %d", &Y, &X);
}



void do_all(void)
{
  if ((Y*X)%3 == 0) {
    casea = 1;
    if (Y*X > 0 && Y > 1 && X > 1) {
      solvea();
    }
  }
  if ((Y*X)%3 == 1) {
    caseb = 1;
    if (Y > 1 && X > 1) {
      solveb();
    }
  }
  if ((Y*X)%3 == 2) {
    casec = 1;
    if (Y > 1 && X > 1) {
      solvec();
    }
  }
}



void solvea(void)
{
  int i, j, d;
  
  if (Y >= 2 && X >= 2 && (X*Y)%6 == 0)  ;
  else  return;
  if ((Y%2 == 0 && X%3 == 0) || (Y%3 == 0 && X%2 == 0))  ;
  else  return;
  d = 1;
  trans = 0;
  if (Y%2 != 0) {
    int t = X; X = Y; Y = t;
    trans = 1;
  }
  for (i = 0; i < Y; i+=2) {
    for (j = 0; j < X; j+=3) {
      g[i][j] = d;
      g[i][j+1] = d;
      g[i+1][j] = d;  d++;
      g[i][j+2] = d;
      g[i+1][j+1] = d;
      g[i+1][j+2] = d;  d++;
    }
  }
  if (trans) {
    int t;
    
    for (i = 0; i < Y; i++) {
      for (j = 0; j < X; j++) {
        g1[j][i] = g[i][j];
      }
    }
    memmove(g, g1, sizeof(g));
    t = X; X = Y; Y = t;
  }
  P = 1;
}



void solveb(void)
{
  int i, j, im1, jm1;
  
  im1 = (Y+1)/2;
  jm1 = (X+1)/2;
  for (i = 0; i < im1; i++)
    for (j = 0; j < jm1; j++)  tocheck[i][j] = 1;
  if (Y == X) {
    for (i = 0; i < im1; i++)
      for (j = 0; j < i; j++)  tocheck[i][j] = 0;
  }
  for (i = 0; i < Y; i++) {
    for (j = 0; j < X; j++ ) {
      if (tocheck[i][j] == 1) {
        memset(g, 0, sizeof(g));
        g[i][j] = 1;
        tocheck[i][j] += bt(0, 0);
        if (tocheck[i][j] >= 2)  P++;
      }
    }
  }
}



void solvec(void)
{
  int i, j, im1, jm1, im2, jm2;
  
  im1 = (Y+1)/2;
  jm1 = (X)/2;
  im2 = (Y)/2;
  jm2 = (X+1)/2;
  memset(tocheck, 0, sizeof(tocheck));
  memset(tocheck1, 0, sizeof(tocheck1));
  for (i = 0; i < im1; i++)
    for (j = 0; j < jm1; j++)  tocheck[i][j] = 1;
  for (i = 0; i < im2; i++)
    for (j = 0; j < jm2; j++)  tocheck1[i][j] = 1;
/*  if (Y == X) {
    for (i = 0; i < im1; i++)
      for (j = 0; j < i; j++)  tocheck[i][j] = 0;
    for (i = 0; i < im2; i++)
      for (j = 0; j <= i; j++)  tocheck1[i][j] = 0;
  }*/
  for (i = 0; i < Y; i++) {
    for (j = 0; j < X; j++ ) {
      if (tocheck[i][j] == 1) {
        memset(g, 0, sizeof(g));
        g[i][j] = 1;
        g[i][j+1] = 1;
        tocheck[i][j] += bt(0, 0);
        if (tocheck[i][j] >= 2)  P++;
      }
      if (tocheck1[i][j] == 1) {
        memset(g, 0, sizeof(g));
        g[i][j] = 1;
        g[i+1][j] = 1;
        tocheck1[i][j] += bt(0, 0);
        if (tocheck1[i][j] >= 2)  P++;
      }
    }
  }
}



int bt(int y, int x)
{
  for (y = y; y < Y; y++) {
    if (x >= X)  x = 0;
    for (x = x; x < X; x++) {
      if (g[y][x] == 0)  break;
    }
    if (x < X)  break;
  }
  if (y == Y && x == X)  return 1;
  g[y][x] = 1;
  if (x+1 < X && g[y][x+1] == 0) {
    g[y][x+1] = 1;
    if (y+1 < Y && g[y+1][x] == 0) {
      g[y+1][x] = 1;
      if (bt(y, x))  return 1;
      g[y+1][x] = 0;
    }
    if (y+1 < Y && g[y+1][x+1] == 0) {
      g[y+1][x+1] = 1;
      if (bt(y, x))  return 1;
      g[y+1][x+1] = 0;
    }
    g[y][x+1] = 0;
  }
  if (y+1 < Y && g[y+1][x] == 0) {
    g[y+1][x] = 1;
    if (x+1 < X && g[y+1][x+1] == 0) {
      g[y+1][x+1] = 1;
      if (bt(y, x))  return 1;
      g[y+1][x+1] = 0;
    }
    if (x-1 >= 0 && g[y+1][x-1] == 0) {
      g[y+1][x-1] = 1;
      if (bt(y, x))  return 1;
      g[y+1][x-1] = 0;
    }
    g[y+1][x] = 0;
  }
  g[y][x] = 0;
  return 0;
}



void write_all(void)
{
  int i, j;
  
  if (casea) {
    int sp[MAXN]={0};
    if (P == 0) {
      printf("0\n");
      return;
    }
    for (j = 0; j < X; j++) {
      sp[j] = 1;
      for (i = 0; i < Y; i++) {
        if (g[i][j] >= 10)  sp[j] = 2;
      }
    }
    for (i = 0; i < Y; i++) {
      for (j = 0; j < X; j++) {
        printf("%*d ", sp[j], g[i][j]);
      }
      printf("\n");
    }
  }
  if (caseb) {
    printf("%d\n", P);
    for (i = 0; i < Y; i++) {
      for (j = 0; j < X; j++) {
        if (tocheck[i][j] == 2) {
          printf("%d %d\n", i+1, j+1);
        }
      }
    }
  }
  if (casec) {
    printf("%d\n", P);
    for (i = 0; i < Y; i++) {
      for (j = 0; j < X; j++) {
        if (tocheck[i][j] == 2) {
          printf("%d %d %d %d\n", i+1, j+1, i+1, j+2);
        }
        if (tocheck1[i][j] == 2) {
          printf("%d %d %d %d\n", i+1, j+1, i+2, j+1);
        }
      }
    }
  }
/*  printf("%d\n", P);*/
}

