type
  need = record
            le, cap : dword;
          end;

var
  a, n, v : integer;
  h : array[1..300] of need;
  hh : array[1..300] of need;
  vis : array[1..300] of boolean;
  min : dword;
  fl : boolean;

Procedure ReadInp;
var
  f : text;
  begin
    assign(f, 'drain.inp');
    reset(f);
    readln(f, n);
    for a := 1 to n do readln(f, h[a].le, h[a].cap);
    close(f);
  end;

Procedure MakeCorr;
var
  t : dword;
  begin
    t := h[1].le;
    for a := 1 to n do h[a].le := h[a].le - t;
  end;

Procedure PreCalc(o : dword);
var
  t : integer;
  begin
    for t := 1 to n do
      if not vis[t] then
        begin
          hh[t].cap := hh[t].cap + h[t].cap * o;
          if hh[t].cap > 2000000000 then fl := true;
        end;
  end;

Function Check(i : integer) : dword;
var
  j : integer;
  sum, p : dword;
  begin
    hh := h;
    for j := 1 to n do hh[j].cap := 0;
    vis[i] := true;
    if i <> 1 then
    for j := i - 1 downto 1 do
      begin
        p := h[j+1].le - h[j].le;
        PreCalc(p);
        if fl then
          begin
            Check := 2000000001;
            exit;
          end;
        vis[j] := true;
      end;
    if i <> n then
    for j := 2 to n do
      begin
        p := h[j].le - h[j-1].le;
        PreCalc(p);
        if fl then
          begin
            Check := 2000000001;
            exit;
          end;
        vis[j] := true;
      end;
    sum := 0;
    for j := 1 to n do
      begin
        sum := sum + hh[j].cap;
        if sum > 2000000000 then
          begin
            Check := 2000000001;
            exit;
          end;
      end;
    Check := sum;
  end;

Procedure Solution;
var
  now : dword;
  begin
    MakeCorr;
    min := 2000000000;
    for a := 1 to n do
      begin
        FillChar(vis, sizeof(vis), false);
        fl := false;
        now := Check(a);
        if now < min then
          begin
            min := now;
            v := a;
          end;
      end;
  end;

Procedure WriteOut;
var
  f : text;
  begin
    assign(f, 'drain.out');
    rewrite(f);
    writeln(f, min);
    writeln(f, v);
    close(f);
  end;

begin
  ReadInp;
  Solution;
  WriteOut;
end.
