Const
        InFile = 'Board.inp';
        OutFile = 'Board.out';

Type
        TPoint = record
                x,y : integer;
        end;


Var
        FIn,FOut : Text;
        a        : array [0..50,0..50] of integer;
        pos      : array [1..1000,1..2] of TPoint;
        count    : integer;
        k        : integer;
        M,N      : integer;

function rec(i,j,k : integer) : boolean;
begin
        if i > n then begin
                inc(j);
                i := 1;
                if j > m then begin
                        rec := true;
                        exit;
                end;
        end;

        if a[i,j] > 0 then begin
                rec := rec(i+1,j,k);
                exit;
        end
        else begin
                a[i,j] := k;

                if a[i+1,j] = 0 then begin
                        if a[i,j+1] = 0 then begin
                                a[i+1,j] := k;
                                a[i,j+1] := k;
                                if rec(i+2,j,k+1) then begin
                                        rec := true;
                                        exit;
                                end;
                                a[i+1,j] := 0;
                                a[i,j+1] := 0;
                        end;
                        if a[i+1,j+1] = 0 then begin
                                a[i+1,j] := k;
                                a[i+1,j+1] := k;
                                if rec(i+2,j,k+1) then begin
                                        rec := true;
                                        exit;
                                end;
                                a[i+1,j] := 0;
                                a[i+1,j+1] := 0;
                        end;
                end;
                if a[i,j+1] = 0 then begin
                        if a[i+1,j+1] = 0 then begin
                                a[i,j+1] := k;
                                a[i+1,j+1] := k;
                                if rec(i+1,j,k+1) then begin
                                        rec := true;
                                        exit;
                                end;
                                a[i,j+1] := 0;
                                a[i+1,j+1] := 0;
                        end;
                        if a[i-1,j+1] = 0 then begin
                                a[i,j+1] := k;
                                a[i-1,j+1] := k;
                                if rec(i+1,j,k+1) then begin
                                        rec := true;
                                        exit;
                                end;
                                a[i,j+1] := 0;
                                a[i-1,j+1] := 0;
                        end;
                end;
                a[i,j] := 0;
        end;

        rec := false;
        exit;
end;

procedure null;
var
        i,j : integer;
begin
        fillchar(a,sizeof(a),0);
        for i := 0 to n+1 do begin
                a[i,0] := MAXINT;
                a[i,m+1] := MAXINT;
        end;
        for i := 1 to m do begin
                a[0,i] := MAXINT;
                a[n+1,i] := MAXINT;
        end;
end;

procedure swap(var a,b : integer);
var
        tmp : integer;
begin
        tmp := a;
        a := b;
        b := tmp;
end;

procedure swapp(var a,b : TPoint);
var
        tmp : TPoint;
begin
        tmp := a;
        a := b;
        b := tmp;
end;

function eq(p1,p2 : TPoint) : boolean;
begin
        eq := (p1.x = p2.x) and (p1.y = p2.y);
end;

function small(p1,p2 : TPoint) : boolean;
begin
        small := (p1.y < p2.y) or ( (p1.y = p2.y) and ( p1.x < p2.x));
end;

function check(P1,P2 : TPoint;var id : integer) : boolean;
var
        i : integer;
begin
        if (p1.x > p2.x) or ( (p1.x = p2.x) and (p1.y > p2.y)) then
                swapP(p1,p2);

        for i := 1 to count do begin
                if eq(p1,pos[i,1]) and eq(p2,pos[i,2]) then begin
                        check := false;
                        id := i;
                        exit;
                end;
        end;

        swap(p1.x,p1.y);
        swap(p2.x,p2.y);

{        p1.x := n - p1.x;
        p2.x := n - p2.x;}

        if (p1.x > p2.x) or ( (p1.x = p2.x) and (p1.y > p2.y))then
              swapP(p1,p2);

        for i := 1 to count do begin
                if eq(p1,pos[i,1]) and eq(p2,pos[i,2]) then begin
                        check := false;
                        id := i;
                        exit;
                end;
        end;

        check := true;
end;

procedure solve;
var
        i,j : integer;
        id  : integer;
        p,p2  : TPoint;
        nulP : TPoint;

begin
        count := 0;
        nulP.x := 10000;
        nulP.y := 10000;

        case m*n mod 3 of
                0 : begin
                        null;
                        if rec(1,1,1) then begin
                                k := m*n div 3;
                                if (k > 10) and (k<100) then
                                        k := 2
                                else
                                        if (k>100) and (k < 1000) then
                                                k := 3
                                        else
                                                if k < 10 then
                                                        k := 1;

                                k := k + 1;
                                for i := 1 to m do begin
                                        for j := 1 to n do
                                                write(FOut,a[j,i]:k);
                                        writeln(FOut);
                                end;
                        end
                        else
                                writeln(FOut,0);
                end;
                1 : begin
                        for i := 1 to m div 2 + m mod 2 do
                                for j := 1 to n div 2 + n mod 2 do begin
                                        p.x := j;       p.y := i;
                                        if check(p,nulP,id) then begin
                                                null;
                                                a[p.x,p.y] := MAXINT;
                                                if rec(1,1,1) then begin
                                                        inc(count);
                                                        pos[count,1] := p;
                                                        pos[count,2] := nulP;
                                                end;
                                        end;
                                end;
                        writeln(FOut,count);
                        for i := 1 to count do
                                writeln(FOut,pos[i,1].y,' ',pos[i,1].x);

                end;
                2 : begin
                        for i := 1 to m div 2 + m mod 2 do
                                for j := 1 to n div 2 + n mod 2 do begin
                                        p.x := j;       p.y := i;
                                        p2.x := j+1;    p2.y := i;
                                        if check(p,p2,id) then begin
                                                null;
                                                a[p.x,p.y] := MAXINT;
                                                a[p2.x,p2.y] := MAXINT;
                                                if rec(1,1,1) then begin
                                                        inc(count);
                                                        pos[count,1] := p;
                                                        pos[count,2] := p2;
                                                end;
                                        end;

                                        p2.x := j;    p2.y := i+1;
                                        if check(p,p2,id) then begin
                                                null;
                                                a[p.x,p.y] := MAXINT;
                                                a[p2.x,p2.y] := MAXINT;
                                                if rec(1,1,1) then begin
                                                        inc(count);
                                                        pos[count,1] := p;
                                                        pos[count,2] := p2;
                                                end;
                                        end;
                                end;
                        writeln(FOut,count);
                        for i := 1 to count do
                                writeln(FOut,pos[i,1].y,' ',pos[i,1].x,' ',pos[i,2].y,' ',pos[i,2].x);

                end;
        end;
end;

Begin
        assign(FIn,InFile);     reset(FIn);
        assign(FOut,OutFile);   rewrite(FOut);
        readln(FIn,M,N);
        close(FIn);
        solve;
        close(FOut);
End.
