Const
        InFile = 'work.inp';
        OutFile = 'work.out';

        MAXN = 1020;
        MAX = 10000;

Type
        PNode = ^TNode;
        TNode = record
                id   : integer;
                l    : integer;
                next : PNode;
        end;

        TGraph = array [1..MAXN] of PNode;

Var
        used     :  array [1..MAXN] of boolean;
        FIn,FOut : Text;
        a        : array [1..MAXN,1..MAXN] of integer;
        g,g1     : TGraph;
        inDagi   : array [1..MAXN] of integer;
        steck    : array [1..MAXN] of integer;
        top      : array [1..MAXN] of integer;
        flag     : boolean;
        count    : integer;
        n,m      : integer;
        i,j,k,l  : integer;

procedure connect(a,b,l : Integer);
var
        w : PNode;
begin
        new(w);
        w^.id := b;
        w^.l := l;
        w^.next := g[a];
        g[a] := w;
        inc(inDagi[b]);
end;

function min(a,b : integer):  integer;
begin
        if a < b then
                min := a
        else
                min := b;
end;


procedure solve;
var
        i : integer;
        w : PNode;
        j : integer;
        t : integer;

begin
{        count := 0;
        for i := 1 to N do
                if inDagi[i] = 0 then begin
                        inc(count);
                        steck[count] := i;
                end;

        if count = 0 then begin
                writeln(FOut,'NO SOLUTION');
        end
        else begin
                j := 0;
                while count > 0 do begin
                        inc(j);
                        i := steck[count];
                        top[j] := i;
                        dec(count);
                        w := g[i];
                        while w <> nil do begin
                               dec(inDagi[w^.id]);
                               if inDagi[w^.id] = 0 then begin
                                        inc(count);
                                        steck[count] := w^.id;
                               end;
                               w := w^.next;
                        end;
                end;
                if j <> N then
                        writeln(FOut,'NO SOLUTION')
                else begin
                        for i := n downto 1 do begin
                                w := g[i];
                                while w <> nil do begin
                                        for j := 1 to N do
                                                if a[w^.id,j] <> max then begin
                                                        t := w^.l + a[w^.id,j];
                                                        a[i,w^.id] := min(t,a[i,w^.id]);
                                                        if a[i,w^.id] + a[w^.id,i] < 0 then begin
                                                                writeln(FOut,'NO SOLUTION');
                                                                exit;
                                                        end;
                                                end;
                                        w := w^.next;
                                end;
                        end;
                end;
        end;}
        writeln(FOut,'NO SOLUTION');
end;

Begin
        assign(FIn,InFile);     reset(FIn);
        assign(FOut,OutFile);   rewrite(FOut);
        readln(FIn,N,M);

        fillchar(inDagi,sizeof(inDagi),0);

        for i := 1 to N do
                for j := 1 to N do
                        a[i,j] := MAX;
        flag := false;

        for i := 1 to M do begin
                readln(FIn,j,k,l);
                a[j,k] := min(a[j,k],l);
                if a[j,k] + a[k,j] < 0 then begin
                        writeln(FOut,'NO SOLUTION');
                        flag := true;
                        break;
                end;
                connect(j,k,l);
        end;
        close(FIn);

        if not flag then
                solve;

        close(FOut);
End.
