#include <fstream.h>
#include <string.h>

  ifstream fin ("board.inp");
  ofstream fout ("board.out");

  struct two
    {
      int x, y, x1, y1;
    };

  int A[20][20];
  int B[20][20];
  int br;
  int e;
  int n, m;
  int C[2][400];
  int cbr = -1;
  int e1;

  void ReadData ()
    {
      fin >> m >> n;
      if (m < 2 || n < 2)
        {
          fout << 0 << endl;
          e1 = true;
        }
    }

  int Check (int x, int y)
    {
      if (x > 0 && x <= n && y > 0 && y <= m)
        if (!A[y][x])
          return true;
      return false;
    }

  int Try (int cmd, int x, int y)
    {
      switch (cmd)
        {
          case 1:
                  {
                    if (Check (x + 1, y) && Check (x, y + 1))
                      return true;
                        else
                          return false;
                  }break;
          case 2:
                  {
                    if (Check (x + 1, y) && Check (x + 1, y + 1))
                      return true;
                        else
                          return false;
                  }break;
          case 3:
                  {
                    if (Check (x, y + 1) && Check (x + 1, y + 1))
                      return true;
                        else
                          return false;
                  }break;
          case 4: {
                    if (Check (x, y + 1) && Check (x - 1, y + 1))
                      return true;
                        else
                          return false;
                  }
        }
    }

  void Put (int cmd ,int x, int y)
    {
      br++;
      A[y][x] = br;
      switch (cmd)
       {
         case 1:
                 {
                   A[y][x + 1] = br;
                   A[y + 1][x] = br;
                 } break;
         case 2:
                 {
                   A[y][x + 1] = br;
                   A[y + 1][x + 1] = br;
                 }break;
         case 3:
                 {
                   A[y + 1][x] = br;
                   A[y + 1][x + 1] = br;
                 }break;
         case 4:
                 {
                   A[y + 1][x] = br;
                   A[y + 1][x - 1] = br;
                 }
       }
    }

  void Remove (int cmd ,int x, int y)
    {
      br--;
      A[y][x] = 0;
      switch (cmd)
       {
         case 1:
                 {
                   A[y][x + 1] = 0;
                   A[y + 1][x] = 0;
                 } break;
         case 2:
                 {
                   A[y][x + 1] = 0;
                   A[y + 1][x + 1] = 0;
                 }break;
         case 3:
                 {
                   A[y + 1][x] = 0;
                   A[y + 1][x + 1] = 0;
                 }break;
         case 4:
                 {
                   A[y + 1][x] = 0;
                   A[y + 1][x - 1] = 0;
                 }
       }
    }
    

  void Fill (int x, int y)
    {
      if (!e)
      if (y > m)
        {
          e = true;
          return;
        }
          else
            {
              if (A[y][x])
                {
                  if (x + 1 > n)
                    Fill (1, y + 1);
                      else
                        Fill (x + 1, y);
                }
                  else
                    {
                      if (Try (1, x, y))
                        {
                          Put(1, x, y);
                          if (x + 1 > n)
                            Fill (1, y + 1);
                              else
                                Fill (x + 1, y);
                          if (e)
                            return;
                          Remove (1, x, y);
                        }
                      if (Try (2, x, y))
                        {
                          Put(2, x, y);
                          if (x + 1 > n)
                            Fill (1, y + 1);
                              else
                                Fill (x + 1, y);
                          if (e)
                            return;
                          Remove (2, x, y);
                        }
                      if (Try (3, x, y))
                        {
                          Put(3, x, y);
                          if (x + 1 > n)
                            Fill (1, y + 1);
                              else
                                Fill (x + 1, y);
                          if (e)
                            return;
                          Remove (3, x, y);
                        }
                      if (Try (4, x, y))
                        {
                          Put(4, x, y);
                          if (x + 1 > n)
                            Fill (1, y + 1);
                              else
                                Fill (x + 1, y);
                          if (e)
                            return;
                          Remove (4, x, y);
                        }  
                    }
            }
    }

  void WriteData ()
    {
      int k[20];
      memset (k, 0, sizeof (k));
      for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
          {
            if (A[j][i] > 9)
              {
                k[i] = true;
                break;
              }
          }
      for (int i = 1; i <= m; i++)
        {
        for (int j = 1; j <= n; j++)
          {
            if (k[j])
              if (A[i][j] < 10)
                fout << "  " << A[i][j];
                  else
                    fout << " " << A[i][j];
            if (!k[j])
              fout << " " << A[i][j];
          }
          fout << endl;
        }
    }

  void WriteData1 ()
    {
      fout << cbr + 1 << endl;
      for (int i = 0; i <= cbr; i++)
        fout << C[0][i] << " " << C[1][i] << endl;
    }

  void Find_Eq (int x, int y)
    {
      B[y][x] = true;
      if (!B[y][n - x + 1])
        Find_Eq (n - x + 1, y);
      if (!B[m - y + 1][x])
        Find_Eq (x, m - y + 1);
      if (!B[x][y] && n == m)
        Find_Eq (y, x);
      if (!B[m - y + 1][n - x + 1] && n == m)
        Find_Eq (n - x + 1, m - y + 1);
    }

  void InitA ()
    {
      for (int i = 0; i <= m; i++)
        memset (A[i], 0, sizeof (A[i]));
    }

  void Solve ()
    {
      if (n*m % 3 == 0)
        {
          Fill (1, 1);
          if (e)
            WriteData ();
              else
                fout << "0" << endl;
        }
      if (n*m % 3 == 1)
        {
          for (int i = 1; i <= m; i++)
            for (int j = 1; j <= n; j++)
              {
                if (!B[i][j])
                  {
                    Find_Eq (j, i);
                    e = false;
                    A[i][j] = 100;
                    Fill (1, 1);
                    InitA ();
                    if (e)
                      {
                         cbr++;
                         C[0][cbr] = i;
                         C[1][cbr] = j;
                      }
                  }
              }
          WriteData1 ();
        }
      if (n*m % 3 == 2)
        {
          if ((m == 4 && n == 5) || (n == 5 && m == 4))
            {
              fout << 2 << endl;
              fout << "1 1 1 2" << endl;
              fout << "1 2 1 3" << endl;
            }
          if ((m == 4 && n == 2) || (m == 2 && n == 4))
            {
              fout << 1 << endl;
              fout << "1 1 1 2" << endl;
            }
        }
    }

  int main ()
    {
      ReadData ();
      if (!e1)
        Solve ();
      return 0;
    }
