#include <stdio.h>
#include <process.h>
int M, N;
FILE* out;
int Board[20][20];
int Color=1;
void Init ()
{
 FILE *inpt=fopen("board.inp","r");
   if(inpt==NULL)  printf("Problem\n");
 fscanf(inpt, "%d %d",&M, &N);
 fclose(inpt);
}
void PrintOut()
{
 FILE* out=fopen("BOARD.OUT","w");
 int i, j;
 for(i=1;i<=M;i++)  {
 for(j=1;j<=N;j++) fprintf(out,"%2d ",Board[i][j]);fprintf(out,"\n");
 }
 fclose(out);
}
void NoSolution()
{
 out=fopen("BOARD.OUT","w");
 fprintf(out,"0\n");
 fclose(out);
 exit(0);
}
void Fill2(int x, int y)
{
 Board[x][y]=Color;
 Board[x+1][y]=Color;
 Board[x][y+1]=Color;Color++;
 Board[x][y+2]=Color;
 Board[x+1][y+2]=Color;
 Board[x+1][y+1]=Color;Color++;
}
void Fill1(int x,int y)
{
 Board[x][y]=Color;
 Board[x][y+1]=Color;
 Board[x+1][y]=Color;Color++;
 Board[x+1][y+1]=Color;
 Board[x+2][y+1]=Color;
 Board[x+2][y]=Color;Color++;
}
void Fill3(int x1, int y1, int x2, int y2)
{
 int i, j;
 for(i=0;i<(x2-x1+1)/3;i++) for (j=0;j<(y2-y1+1)/2;j++) Fill1(x1+3*i,y1+2*j);
}
void Fill4(int x1, int y1, int x2, int y2)
{
 int i, j;
 for(i=0;i<(x2-x1+1)/2;i++) for (j=0;j<(y2-y1+1)/3;j++) Fill2(x1+2*i,y1+3*j);
}


void Case1()
{
 if ((M*N)%6!=0) NoSolution();
 if (((M%3)==0)&&((N%2)==0))
 {
  Fill3(1,1,M,N);
  PrintOut();
  exit(0);
 }
if (((M%2)==0)&&((N%3)==0))
{
     Fill4(1,1,M,N);
     PrintOut();
     exit(0);
 }
if((M%6)==0)
{
 Fill4(1,1,M,3);
 Fill3(1,4,M,N);
 PrintOut();
 exit(0);
}
if ((N%6)==0)
{
 Fill3(1,1,3,N);
 Fill4(4,1,M,N);
 PrintOut();
 exit(0);
}

}

void Case2()
{
}
void Case3()
{
}

void main()
{
 Init();
 if(M<2) NoSolution();
 if(N<2) NoSolution();
 if( (M*N)%3==0) Case1();
 if( (M*N)%3==1) Case2();
 if( (M*N)%3==2) Case3();
}