#include <stdio.h>

int ots_c;
long res;

struct s_point { unsigned int x, y; };
struct s_ots   { struct s_point crd[2]; } ots[10000];

int orient(struct s_point a, struct s_point b, struct s_point c)  { return (a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y)); }
int cross(struct s_ots p, struct s_ots q)  { if((orient(p.crd[0], p.crd[1], q.crd[0])*orient(p.crd[0], p.crd[1], q.crd[1]) <= 0) && (orient(q.crd[0], q.crd[1], p.crd[0])*orient(q.crd[0], q.crd[1], p.crd[1]) <= 0)) return 1; else return 0; }

int main(void)  {

  FILE *fp;

  int i, j;

  fp = fopen("ots.inp", "rt");

  while(!feof(fp)) { fscanf(fp, "%d %d %d %d", &ots[ots_c].crd[0].x, &ots[ots_c].crd[0].y, &ots[ots_c].crd[1].x, &ots[ots_c].crd[1].y); ots_c++; } ots_c--;

  fclose(fp);

  for(i=0;i<ots_c-1;i++)  {
   for(j=i+1;j<ots_c;j++)  {
    if(cross(ots[i], ots[j])) res++;
   }
  }

  fp = fopen("ots.out", "w+");

  fprintf(fp, "%lu", res);

  fclose(fp);
  
  return 0;
}
